

-- UUAGC 0.9.36 (src/ExtractAbc.ag)
module ExtractAbc(extractAbcFiles) where

{-# LINE 6 "src/ExtractAbc.ag" #-}

import Data.ByteString.Lazy(ByteString)
import ByteCode
import Data.Word
{-# LINE 12 "dist/src/sdist.27680/asil-1.2/dist/build/ExtractAbc.hs" #-}

{-# LINE 15 "src/ExtractAbc.ag" #-}


extractAbcFiles :: SwfFile -> AbcFiles
extractAbcFiles m = out where
  inh = Inh_SwfFile {}
  sem = sem_SwfFile m
  syn = wrap_SwfFile sem inh
  out = output_Syn_SwfFile syn
{-# LINE 23 "dist/src/sdist.27680/asil-1.2/dist/build/ExtractAbc.hs" #-}
-- AbcFile -----------------------------------------------------
-- cata
sem_AbcFile :: AbcFile  ->
               T_AbcFile 
sem_AbcFile (AbcFile_File _minorVersion _majorVersion _constantPool _methods _metadatas _instances _classes _scripts _bodies )  =
    (sem_AbcFile_File _minorVersion _majorVersion (sem_PoolInfo _constantPool ) (sem_MethodInfos _methods ) (sem_MetaInfos _metadatas ) (sem_InstanceInfos _instances ) (sem_ClassInfos _classes ) (sem_ScriptInfos _scripts ) (sem_BodyInfos _bodies ) )
-- semantic domain
type T_AbcFile  = ( AbcFile )
sem_AbcFile_File :: Word16 ->
                    Word16 ->
                    T_PoolInfo  ->
                    T_MethodInfos  ->
                    T_MetaInfos  ->
                    T_InstanceInfos  ->
                    T_ClassInfos  ->
                    T_ScriptInfos  ->
                    T_BodyInfos  ->
                    T_AbcFile 
sem_AbcFile_File minorVersion_ majorVersion_ constantPool_ methods_ metadatas_ instances_ classes_ scripts_ bodies_  =
    (case (bodies_ ) of
     { ( _bodiesIself) | True ->
         (case (scripts_ ) of
          { ( _scriptsIself) | True ->
              (case (classes_ ) of
               { ( _classesIself) | True ->
                   (case (instances_ ) of
                    { ( _instancesIself) | True ->
                        (case (metadatas_ ) of
                         { ( _metadatasIself) | True ->
                             (case (methods_ ) of
                              { ( _methodsIself) | True ->
                                  (case (constantPool_ ) of
                                   { ( _constantPoolIself) | True ->
                                       (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
                                               AbcFile_File minorVersion_ majorVersion_ _constantPoolIself _methodsIself _metadatasIself _instancesIself _classesIself _scriptsIself _bodiesIself
                                               {-# LINE 59 "src/ExtractAbc.hs" #-}
                                               )) of
                                        { _self | _self `seq` (True) ->
                                        (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
                                                _self
                                                {-# LINE 64 "src/ExtractAbc.hs" #-}
                                                )) of
                                         { _lhsOself | _lhsOself `seq` (True) ->
                                         ( _lhsOself) }) }) }) }) }) }) }) }) })
-- AbcFlag -----------------------------------------------------
-- cata
sem_AbcFlag :: AbcFlag  ->
               T_AbcFlag 
sem_AbcFlag (AbcFlag_LazyInit )  =
    (sem_AbcFlag_LazyInit )
-- semantic domain
type T_AbcFlag  = ( )
sem_AbcFlag_LazyInit :: T_AbcFlag 
sem_AbcFlag_LazyInit  =
    ( )
-- AbcFlags ----------------------------------------------------
-- cata
sem_AbcFlags :: AbcFlags  ->
                T_AbcFlags 
sem_AbcFlags list  =
    (Prelude.foldr sem_AbcFlags_Cons sem_AbcFlags_Nil (Prelude.map sem_AbcFlag list) )
-- semantic domain
type T_AbcFlags  = ( )
sem_AbcFlags_Cons :: T_AbcFlag  ->
                     T_AbcFlags  ->
                     T_AbcFlags 
sem_AbcFlags_Cons hd_ tl_  =
    ( )
sem_AbcFlags_Nil :: T_AbcFlags 
sem_AbcFlags_Nil  =
    ( )
-- BodyInfo ----------------------------------------------------
-- cata
sem_BodyInfo :: BodyInfo  ->
                T_BodyInfo 
sem_BodyInfo (BodyInfo_Info _method _maxStack _localCount _initScopeDepth _maxScopeDepth _instructions _exceptions _traits )  =
    (sem_BodyInfo_Info _method _maxStack _localCount _initScopeDepth _maxScopeDepth (sem_Instructions _instructions ) (sem_Exceptions _exceptions ) (sem_Traits _traits ) )
-- semantic domain
type T_BodyInfo  = ( BodyInfo )
sem_BodyInfo_Info :: Word32 ->
                     Word32 ->
                     Word32 ->
                     Word32 ->
                     Word32 ->
                     T_Instructions  ->
                     T_Exceptions  ->
                     T_Traits  ->
                     T_BodyInfo 
sem_BodyInfo_Info method_ maxStack_ localCount_ initScopeDepth_ maxScopeDepth_ instructions_ exceptions_ traits_  =
    (case (traits_ ) of
     { ( _traitsIself) | True ->
         (case (exceptions_ ) of
          { ( _exceptionsIself) | True ->
              (case (instructions_ ) of
               { ( _instructionsIself) | True ->
                   (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
                           BodyInfo_Info method_ maxStack_ localCount_ initScopeDepth_ maxScopeDepth_ _instructionsIself _exceptionsIself _traitsIself
                           {-# LINE 121 "src/ExtractAbc.hs" #-}
                           )) of
                    { _self | _self `seq` (True) ->
                    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
                            _self
                            {-# LINE 126 "src/ExtractAbc.hs" #-}
                            )) of
                     { _lhsOself | _lhsOself `seq` (True) ->
                     ( _lhsOself) }) }) }) }) })
-- BodyInfos ---------------------------------------------------
-- cata
sem_BodyInfos :: BodyInfos  ->
                 T_BodyInfos 
sem_BodyInfos list  =
    (Prelude.foldr sem_BodyInfos_Cons sem_BodyInfos_Nil (Prelude.map sem_BodyInfo list) )
-- semantic domain
type T_BodyInfos  = ( BodyInfos )
sem_BodyInfos_Cons :: T_BodyInfo  ->
                      T_BodyInfos  ->
                      T_BodyInfos 
sem_BodyInfos_Cons hd_ tl_  =
    (case (tl_ ) of
     { ( _tlIself) | True ->
         (case (hd_ ) of
          { ( _hdIself) | True ->
              (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
                      (:) _hdIself _tlIself
                      {-# LINE 148 "src/ExtractAbc.hs" #-}
                      )) of
               { _self | _self `seq` (True) ->
               (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
                       _self
                       {-# LINE 153 "src/ExtractAbc.hs" #-}
                       )) of
                { _lhsOself | _lhsOself `seq` (True) ->
                ( _lhsOself) }) }) }) })
sem_BodyInfos_Nil :: T_BodyInfos 
sem_BodyInfos_Nil  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            []
            {-# LINE 161 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 166 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
-- CaseOffsets -------------------------------------------------
-- cata
sem_CaseOffsets :: CaseOffsets  ->
                   T_CaseOffsets 
sem_CaseOffsets list  =
    (Prelude.foldr sem_CaseOffsets_Cons sem_CaseOffsets_Nil list )
-- semantic domain
type T_CaseOffsets  = ( CaseOffsets )
sem_CaseOffsets_Cons :: Word32 ->
                        T_CaseOffsets  ->
                        T_CaseOffsets 
sem_CaseOffsets_Cons hd_ tl_  =
    (case (tl_ ) of
     { ( _tlIself) | True ->
         (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
                 (:) hd_ _tlIself
                 {-# LINE 186 "src/ExtractAbc.hs" #-}
                 )) of
          { _self | _self `seq` (True) ->
          (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
                  _self
                  {-# LINE 191 "src/ExtractAbc.hs" #-}
                  )) of
           { _lhsOself | _lhsOself `seq` (True) ->
           ( _lhsOself) }) }) })
sem_CaseOffsets_Nil :: T_CaseOffsets 
sem_CaseOffsets_Nil  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            []
            {-# LINE 199 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 204 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
-- ClassInfo ---------------------------------------------------
-- cata
sem_ClassInfo :: ClassInfo  ->
                 T_ClassInfo 
sem_ClassInfo (ClassInfo_Info _con _traits )  =
    (sem_ClassInfo_Info _con (sem_Traits _traits ) )
-- semantic domain
type T_ClassInfo  = ( ClassInfo )
sem_ClassInfo_Info :: Word32 ->
                      T_Traits  ->
                      T_ClassInfo 
sem_ClassInfo_Info con_ traits_  =
    (case (traits_ ) of
     { ( _traitsIself) | True ->
         (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
                 ClassInfo_Info con_ _traitsIself
                 {-# LINE 224 "src/ExtractAbc.hs" #-}
                 )) of
          { _self | _self `seq` (True) ->
          (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
                  _self
                  {-# LINE 229 "src/ExtractAbc.hs" #-}
                  )) of
           { _lhsOself | _lhsOself `seq` (True) ->
           ( _lhsOself) }) }) })
-- ClassInfos --------------------------------------------------
-- cata
sem_ClassInfos :: ClassInfos  ->
                  T_ClassInfos 
sem_ClassInfos list  =
    (Prelude.foldr sem_ClassInfos_Cons sem_ClassInfos_Nil (Prelude.map sem_ClassInfo list) )
-- semantic domain
type T_ClassInfos  = ( ClassInfos )
sem_ClassInfos_Cons :: T_ClassInfo  ->
                       T_ClassInfos  ->
                       T_ClassInfos 
sem_ClassInfos_Cons hd_ tl_  =
    (case (tl_ ) of
     { ( _tlIself) | True ->
         (case (hd_ ) of
          { ( _hdIself) | True ->
              (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
                      (:) _hdIself _tlIself
                      {-# LINE 251 "src/ExtractAbc.hs" #-}
                      )) of
               { _self | _self `seq` (True) ->
               (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
                       _self
                       {-# LINE 256 "src/ExtractAbc.hs" #-}
                       )) of
                { _lhsOself | _lhsOself `seq` (True) ->
                ( _lhsOself) }) }) }) })
sem_ClassInfos_Nil :: T_ClassInfos 
sem_ClassInfos_Nil  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            []
            {-# LINE 264 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 269 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
-- DebugType ---------------------------------------------------
-- cata
sem_DebugType :: DebugType  ->
                 T_DebugType 
sem_DebugType (DebugType_Local )  =
    (sem_DebugType_Local )
-- semantic domain
type T_DebugType  = ( DebugType )
sem_DebugType_Local :: T_DebugType 
sem_DebugType_Local  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            DebugType_Local
            {-# LINE 285 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 290 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
-- Exception ---------------------------------------------------
-- cata
sem_Exception :: Exception  ->
                 T_Exception 
sem_Exception (Exception_Info _from _to _target _tp _name )  =
    (sem_Exception_Info _from _to _target _tp _name )
-- semantic domain
type T_Exception  = ( Exception )
sem_Exception_Info :: Word32 ->
                      Word32 ->
                      Word32 ->
                      Word32 ->
                      Word32 ->
                      T_Exception 
sem_Exception_Info from_ to_ target_ tp_ name_  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Exception_Info from_ to_ target_ tp_ name_
            {-# LINE 311 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 316 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
-- Exceptions --------------------------------------------------
-- cata
sem_Exceptions :: Exceptions  ->
                  T_Exceptions 
sem_Exceptions list  =
    (Prelude.foldr sem_Exceptions_Cons sem_Exceptions_Nil (Prelude.map sem_Exception list) )
-- semantic domain
type T_Exceptions  = ( Exceptions )
sem_Exceptions_Cons :: T_Exception  ->
                       T_Exceptions  ->
                       T_Exceptions 
sem_Exceptions_Cons hd_ tl_  =
    (case (tl_ ) of
     { ( _tlIself) | True ->
         (case (hd_ ) of
          { ( _hdIself) | True ->
              (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
                      (:) _hdIself _tlIself
                      {-# LINE 338 "src/ExtractAbc.hs" #-}
                      )) of
               { _self | _self `seq` (True) ->
               (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
                       _self
                       {-# LINE 343 "src/ExtractAbc.hs" #-}
                       )) of
                { _lhsOself | _lhsOself `seq` (True) ->
                ( _lhsOself) }) }) }) })
sem_Exceptions_Nil :: T_Exceptions 
sem_Exceptions_Nil  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            []
            {-# LINE 351 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 356 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
-- InstanceFlag ------------------------------------------------
-- cata
sem_InstanceFlag :: InstanceFlag  ->
                    T_InstanceFlag 
sem_InstanceFlag (InstanceFlag_ClassFinal )  =
    (sem_InstanceFlag_ClassFinal )
sem_InstanceFlag (InstanceFlag_ClassInterface )  =
    (sem_InstanceFlag_ClassInterface )
sem_InstanceFlag (InstanceFlag_ClassProtected )  =
    (sem_InstanceFlag_ClassProtected )
sem_InstanceFlag (InstanceFlag_ClassSealed )  =
    (sem_InstanceFlag_ClassSealed )
-- semantic domain
type T_InstanceFlag  = ( InstanceFlag )
sem_InstanceFlag_ClassFinal :: T_InstanceFlag 
sem_InstanceFlag_ClassFinal  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            InstanceFlag_ClassFinal
            {-# LINE 378 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 383 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_InstanceFlag_ClassInterface :: T_InstanceFlag 
sem_InstanceFlag_ClassInterface  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            InstanceFlag_ClassInterface
            {-# LINE 391 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 396 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_InstanceFlag_ClassProtected :: T_InstanceFlag 
sem_InstanceFlag_ClassProtected  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            InstanceFlag_ClassProtected
            {-# LINE 404 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 409 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_InstanceFlag_ClassSealed :: T_InstanceFlag 
sem_InstanceFlag_ClassSealed  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            InstanceFlag_ClassSealed
            {-# LINE 417 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 422 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
-- InstanceFlags -----------------------------------------------
-- cata
sem_InstanceFlags :: InstanceFlags  ->
                     T_InstanceFlags 
sem_InstanceFlags list  =
    (Prelude.foldr sem_InstanceFlags_Cons sem_InstanceFlags_Nil (Prelude.map sem_InstanceFlag list) )
-- semantic domain
type T_InstanceFlags  = ( InstanceFlags )
sem_InstanceFlags_Cons :: T_InstanceFlag  ->
                          T_InstanceFlags  ->
                          T_InstanceFlags 
sem_InstanceFlags_Cons hd_ tl_  =
    (case (tl_ ) of
     { ( _tlIself) | True ->
         (case (hd_ ) of
          { ( _hdIself) | True ->
              (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
                      (:) _hdIself _tlIself
                      {-# LINE 444 "src/ExtractAbc.hs" #-}
                      )) of
               { _self | _self `seq` (True) ->
               (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
                       _self
                       {-# LINE 449 "src/ExtractAbc.hs" #-}
                       )) of
                { _lhsOself | _lhsOself `seq` (True) ->
                ( _lhsOself) }) }) }) })
sem_InstanceFlags_Nil :: T_InstanceFlags 
sem_InstanceFlags_Nil  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            []
            {-# LINE 457 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 462 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
-- InstanceInfo ------------------------------------------------
-- cata
sem_InstanceInfo :: InstanceInfo  ->
                    T_InstanceInfo 
sem_InstanceInfo (InstanceInfo_Info _name _super _flags _protectedNs _interfaces _constructor _traits )  =
    (sem_InstanceInfo_Info _name _super (sem_InstanceFlags _flags ) _protectedNs (sem_Interfaces _interfaces ) _constructor (sem_Traits _traits ) )
-- semantic domain
type T_InstanceInfo  = ( InstanceInfo )
sem_InstanceInfo_Info :: Word32 ->
                         Word32 ->
                         T_InstanceFlags  ->
                         Word32 ->
                         T_Interfaces  ->
                         Word32 ->
                         T_Traits  ->
                         T_InstanceInfo 
sem_InstanceInfo_Info name_ super_ flags_ protectedNs_ interfaces_ constructor_ traits_  =
    (case (traits_ ) of
     { ( _traitsIself) | True ->
         (case (interfaces_ ) of
          { ( _interfacesIself) | True ->
              (case (flags_ ) of
               { ( _flagsIself) | True ->
                   (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
                           InstanceInfo_Info name_ super_ _flagsIself protectedNs_ _interfacesIself constructor_ _traitsIself
                           {-# LINE 491 "src/ExtractAbc.hs" #-}
                           )) of
                    { _self | _self `seq` (True) ->
                    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
                            _self
                            {-# LINE 496 "src/ExtractAbc.hs" #-}
                            )) of
                     { _lhsOself | _lhsOself `seq` (True) ->
                     ( _lhsOself) }) }) }) }) })
-- InstanceInfos -----------------------------------------------
-- cata
sem_InstanceInfos :: InstanceInfos  ->
                     T_InstanceInfos 
sem_InstanceInfos list  =
    (Prelude.foldr sem_InstanceInfos_Cons sem_InstanceInfos_Nil (Prelude.map sem_InstanceInfo list) )
-- semantic domain
type T_InstanceInfos  = ( InstanceInfos )
sem_InstanceInfos_Cons :: T_InstanceInfo  ->
                          T_InstanceInfos  ->
                          T_InstanceInfos 
sem_InstanceInfos_Cons hd_ tl_  =
    (case (tl_ ) of
     { ( _tlIself) | True ->
         (case (hd_ ) of
          { ( _hdIself) | True ->
              (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
                      (:) _hdIself _tlIself
                      {-# LINE 518 "src/ExtractAbc.hs" #-}
                      )) of
               { _self | _self `seq` (True) ->
               (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
                       _self
                       {-# LINE 523 "src/ExtractAbc.hs" #-}
                       )) of
                { _lhsOself | _lhsOself `seq` (True) ->
                ( _lhsOself) }) }) }) })
sem_InstanceInfos_Nil :: T_InstanceInfos 
sem_InstanceInfos_Nil  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            []
            {-# LINE 531 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 536 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
-- Instruction -------------------------------------------------
-- cata
sem_Instruction :: Instruction  ->
                   T_Instruction 
sem_Instruction (Instruction_Add )  =
    (sem_Instruction_Add )
sem_Instruction (Instruction_Add_d )  =
    (sem_Instruction_Add_d )
sem_Instruction (Instruction_Add_i )  =
    (sem_Instruction_Add_i )
sem_Instruction (Instruction_ApplyType _name )  =
    (sem_Instruction_ApplyType _name )
sem_Instruction (Instruction_AsType _name )  =
    (sem_Instruction_AsType _name )
sem_Instruction (Instruction_AsTypeLate )  =
    (sem_Instruction_AsTypeLate )
sem_Instruction (Instruction_BitAnd )  =
    (sem_Instruction_BitAnd )
sem_Instruction (Instruction_BitNot )  =
    (sem_Instruction_BitNot )
sem_Instruction (Instruction_BitOr )  =
    (sem_Instruction_BitOr )
sem_Instruction (Instruction_BitXor )  =
    (sem_Instruction_BitXor )
sem_Instruction (Instruction_BreakLine _line )  =
    (sem_Instruction_BreakLine _line )
sem_Instruction (Instruction_Breakpoint )  =
    (sem_Instruction_Breakpoint )
sem_Instruction (Instruction_Call _argCount )  =
    (sem_Instruction_Call _argCount )
sem_Instruction (Instruction_CallInterface _name _argCount )  =
    (sem_Instruction_CallInterface _name _argCount )
sem_Instruction (Instruction_CallMethod _index _argCount )  =
    (sem_Instruction_CallMethod _index _argCount )
sem_Instruction (Instruction_CallProp _name _argCount )  =
    (sem_Instruction_CallProp _name _argCount )
sem_Instruction (Instruction_CallPropLex _name _argCount )  =
    (sem_Instruction_CallPropLex _name _argCount )
sem_Instruction (Instruction_CallPropVoid _name _argCount )  =
    (sem_Instruction_CallPropVoid _name _argCount )
sem_Instruction (Instruction_CallStatic _method _argCount )  =
    (sem_Instruction_CallStatic _method _argCount )
sem_Instruction (Instruction_CallSuper _name _argCount )  =
    (sem_Instruction_CallSuper _name _argCount )
sem_Instruction (Instruction_CallSuperId )  =
    (sem_Instruction_CallSuperId )
sem_Instruction (Instruction_CallSuperVoid _name _argCount )  =
    (sem_Instruction_CallSuperVoid _name _argCount )
sem_Instruction (Instruction_CheckFilter )  =
    (sem_Instruction_CheckFilter )
sem_Instruction (Instruction_Coerce _name )  =
    (sem_Instruction_Coerce _name )
sem_Instruction (Instruction_Coerce_a )  =
    (sem_Instruction_Coerce_a )
sem_Instruction (Instruction_Coerce_b )  =
    (sem_Instruction_Coerce_b )
sem_Instruction (Instruction_Coerce_d )  =
    (sem_Instruction_Coerce_d )
sem_Instruction (Instruction_Coerce_i )  =
    (sem_Instruction_Coerce_i )
sem_Instruction (Instruction_Coerce_o )  =
    (sem_Instruction_Coerce_o )
sem_Instruction (Instruction_Coerce_s )  =
    (sem_Instruction_Coerce_s )
sem_Instruction (Instruction_Coerce_u )  =
    (sem_Instruction_Coerce_u )
sem_Instruction (Instruction_Concat )  =
    (sem_Instruction_Concat )
sem_Instruction (Instruction_Construct _argCount )  =
    (sem_Instruction_Construct _argCount )
sem_Instruction (Instruction_ConstructProp _name _argCount )  =
    (sem_Instruction_ConstructProp _name _argCount )
sem_Instruction (Instruction_ConstructSuper _argCount )  =
    (sem_Instruction_ConstructSuper _argCount )
sem_Instruction (Instruction_Convert_b )  =
    (sem_Instruction_Convert_b )
sem_Instruction (Instruction_Convert_d )  =
    (sem_Instruction_Convert_d )
sem_Instruction (Instruction_Convert_i )  =
    (sem_Instruction_Convert_i )
sem_Instruction (Instruction_Convert_o )  =
    (sem_Instruction_Convert_o )
sem_Instruction (Instruction_Convert_s )  =
    (sem_Instruction_Convert_s )
sem_Instruction (Instruction_Convert_u )  =
    (sem_Instruction_Convert_u )
sem_Instruction (Instruction_Debug _tp _name _reg _extra )  =
    (sem_Instruction_Debug (sem_DebugType _tp ) _name _reg _extra )
sem_Instruction (Instruction_DebugFile _name )  =
    (sem_Instruction_DebugFile _name )
sem_Instruction (Instruction_DebugLine _line )  =
    (sem_Instruction_DebugLine _line )
sem_Instruction (Instruction_DecLocal _reg )  =
    (sem_Instruction_DecLocal _reg )
sem_Instruction (Instruction_DecLocal_i _reg )  =
    (sem_Instruction_DecLocal_i _reg )
sem_Instruction (Instruction_Decrement )  =
    (sem_Instruction_Decrement )
sem_Instruction (Instruction_Decrement_i )  =
    (sem_Instruction_Decrement_i )
sem_Instruction (Instruction_DeleteProperty _name )  =
    (sem_Instruction_DeleteProperty _name )
sem_Instruction (Instruction_DeletePropertyLate )  =
    (sem_Instruction_DeletePropertyLate )
sem_Instruction (Instruction_Divide )  =
    (sem_Instruction_Divide )
sem_Instruction (Instruction_Dup )  =
    (sem_Instruction_Dup )
sem_Instruction (Instruction_Dxns _name )  =
    (sem_Instruction_Dxns _name )
sem_Instruction (Instruction_DxnsLate )  =
    (sem_Instruction_DxnsLate )
sem_Instruction (Instruction_Equals )  =
    (sem_Instruction_Equals )
sem_Instruction (Instruction_EscXAttr )  =
    (sem_Instruction_EscXAttr )
sem_Instruction (Instruction_EscXElem )  =
    (sem_Instruction_EscXElem )
sem_Instruction (Instruction_FindDef _name )  =
    (sem_Instruction_FindDef _name )
sem_Instruction (Instruction_FindPropStrict _name )  =
    (sem_Instruction_FindPropStrict _name )
sem_Instruction (Instruction_FindProperty _name )  =
    (sem_Instruction_FindProperty _name )
sem_Instruction (Instruction_FindPropertyGlobal _name )  =
    (sem_Instruction_FindPropertyGlobal _name )
sem_Instruction (Instruction_FindPropertyGlobalStrict _name )  =
    (sem_Instruction_FindPropertyGlobalStrict _name )
sem_Instruction (Instruction_GetDescendants _name )  =
    (sem_Instruction_GetDescendants _name )
sem_Instruction (Instruction_GetGlobalScope )  =
    (sem_Instruction_GetGlobalScope )
sem_Instruction (Instruction_GetGlobalSlot _slot )  =
    (sem_Instruction_GetGlobalSlot _slot )
sem_Instruction (Instruction_GetLex _name )  =
    (sem_Instruction_GetLex _name )
sem_Instruction (Instruction_GetLocal _reg )  =
    (sem_Instruction_GetLocal _reg )
sem_Instruction (Instruction_GetLocal0 )  =
    (sem_Instruction_GetLocal0 )
sem_Instruction (Instruction_GetLocal1 )  =
    (sem_Instruction_GetLocal1 )
sem_Instruction (Instruction_GetLocal2 )  =
    (sem_Instruction_GetLocal2 )
sem_Instruction (Instruction_GetLocal3 )  =
    (sem_Instruction_GetLocal3 )
sem_Instruction (Instruction_GetOuterScope _name )  =
    (sem_Instruction_GetOuterScope _name )
sem_Instruction (Instruction_GetProperty _name )  =
    (sem_Instruction_GetProperty _name )
sem_Instruction (Instruction_GetScopeObject _index )  =
    (sem_Instruction_GetScopeObject _index )
sem_Instruction (Instruction_GetSlot _slot )  =
    (sem_Instruction_GetSlot _slot )
sem_Instruction (Instruction_GetSuper _name )  =
    (sem_Instruction_GetSuper _name )
sem_Instruction (Instruction_GreaterEquals )  =
    (sem_Instruction_GreaterEquals )
sem_Instruction (Instruction_GreaterThan )  =
    (sem_Instruction_GreaterThan )
sem_Instruction (Instruction_HasNext )  =
    (sem_Instruction_HasNext )
sem_Instruction (Instruction_HasNext2 _objectReg _indexReg )  =
    (sem_Instruction_HasNext2 _objectReg _indexReg )
sem_Instruction (Instruction_IfEq _offset )  =
    (sem_Instruction_IfEq _offset )
sem_Instruction (Instruction_IfFalse _offset )  =
    (sem_Instruction_IfFalse _offset )
sem_Instruction (Instruction_IfGe _offset )  =
    (sem_Instruction_IfGe _offset )
sem_Instruction (Instruction_IfGt _offset )  =
    (sem_Instruction_IfGt _offset )
sem_Instruction (Instruction_IfLe _offset )  =
    (sem_Instruction_IfLe _offset )
sem_Instruction (Instruction_IfLt _offset )  =
    (sem_Instruction_IfLt _offset )
sem_Instruction (Instruction_IfNGe _offset )  =
    (sem_Instruction_IfNGe _offset )
sem_Instruction (Instruction_IfNGt _offset )  =
    (sem_Instruction_IfNGt _offset )
sem_Instruction (Instruction_IfNLe _offset )  =
    (sem_Instruction_IfNLe _offset )
sem_Instruction (Instruction_IfNLt _offset )  =
    (sem_Instruction_IfNLt _offset )
sem_Instruction (Instruction_IfNe _offset )  =
    (sem_Instruction_IfNe _offset )
sem_Instruction (Instruction_IfStrictEq _offset )  =
    (sem_Instruction_IfStrictEq _offset )
sem_Instruction (Instruction_IfStrictNe _offset )  =
    (sem_Instruction_IfStrictNe _offset )
sem_Instruction (Instruction_IfTrue _offset )  =
    (sem_Instruction_IfTrue _offset )
sem_Instruction (Instruction_In )  =
    (sem_Instruction_In )
sem_Instruction (Instruction_IncLocal _reg )  =
    (sem_Instruction_IncLocal _reg )
sem_Instruction (Instruction_IncLocal_i _reg )  =
    (sem_Instruction_IncLocal_i _reg )
sem_Instruction (Instruction_Increment )  =
    (sem_Instruction_Increment )
sem_Instruction (Instruction_Increment_i )  =
    (sem_Instruction_Increment_i )
sem_Instruction (Instruction_InitProperty _name )  =
    (sem_Instruction_InitProperty _name )
sem_Instruction (Instruction_InstanceOf )  =
    (sem_Instruction_InstanceOf )
sem_Instruction (Instruction_IsType _name )  =
    (sem_Instruction_IsType _name )
sem_Instruction (Instruction_IsTypeLate )  =
    (sem_Instruction_IsTypeLate )
sem_Instruction (Instruction_Jump _offset )  =
    (sem_Instruction_Jump _offset )
sem_Instruction (Instruction_Kill _reg )  =
    (sem_Instruction_Kill _reg )
sem_Instruction (Instruction_Label )  =
    (sem_Instruction_Label )
sem_Instruction (Instruction_LessEquals )  =
    (sem_Instruction_LessEquals )
sem_Instruction (Instruction_LessThan )  =
    (sem_Instruction_LessThan )
sem_Instruction (Instruction_LoadFloat32 )  =
    (sem_Instruction_LoadFloat32 )
sem_Instruction (Instruction_LoadFloat64 )  =
    (sem_Instruction_LoadFloat64 )
sem_Instruction (Instruction_LoadIndirect16 )  =
    (sem_Instruction_LoadIndirect16 )
sem_Instruction (Instruction_LoadIndirect32 )  =
    (sem_Instruction_LoadIndirect32 )
sem_Instruction (Instruction_LoadIndirect8 )  =
    (sem_Instruction_LoadIndirect8 )
sem_Instruction (Instruction_Location _index )  =
    (sem_Instruction_Location _index )
sem_Instruction (Instruction_LookupSwitch _defaultOffset _caseOffsets )  =
    (sem_Instruction_LookupSwitch _defaultOffset (sem_CaseOffsets _caseOffsets ) )
sem_Instruction (Instruction_Lshift )  =
    (sem_Instruction_Lshift )
sem_Instruction (Instruction_Modulo )  =
    (sem_Instruction_Modulo )
sem_Instruction (Instruction_Multiply )  =
    (sem_Instruction_Multiply )
sem_Instruction (Instruction_Multiply_i )  =
    (sem_Instruction_Multiply_i )
sem_Instruction (Instruction_Negate )  =
    (sem_Instruction_Negate )
sem_Instruction (Instruction_Negate_i )  =
    (sem_Instruction_Negate_i )
sem_Instruction (Instruction_NewActivation )  =
    (sem_Instruction_NewActivation )
sem_Instruction (Instruction_NewArray _argCount )  =
    (sem_Instruction_NewArray _argCount )
sem_Instruction (Instruction_NewCatch _exception )  =
    (sem_Instruction_NewCatch _exception )
sem_Instruction (Instruction_NewClass _class )  =
    (sem_Instruction_NewClass _class )
sem_Instruction (Instruction_NewFunction _method )  =
    (sem_Instruction_NewFunction _method )
sem_Instruction (Instruction_NewObject _argCount )  =
    (sem_Instruction_NewObject _argCount )
sem_Instruction (Instruction_NextName )  =
    (sem_Instruction_NextName )
sem_Instruction (Instruction_NextValue )  =
    (sem_Instruction_NextValue )
sem_Instruction (Instruction_Nop )  =
    (sem_Instruction_Nop )
sem_Instruction (Instruction_Not )  =
    (sem_Instruction_Not )
sem_Instruction (Instruction_Pop )  =
    (sem_Instruction_Pop )
sem_Instruction (Instruction_PopScope )  =
    (sem_Instruction_PopScope )
sem_Instruction (Instruction_PushByte _val )  =
    (sem_Instruction_PushByte _val )
sem_Instruction (Instruction_PushDouble _name )  =
    (sem_Instruction_PushDouble _name )
sem_Instruction (Instruction_PushFalse )  =
    (sem_Instruction_PushFalse )
sem_Instruction (Instruction_PushInt _name )  =
    (sem_Instruction_PushInt _name )
sem_Instruction (Instruction_PushNaN )  =
    (sem_Instruction_PushNaN )
sem_Instruction (Instruction_PushNamespace _name )  =
    (sem_Instruction_PushNamespace _name )
sem_Instruction (Instruction_PushNull )  =
    (sem_Instruction_PushNull )
sem_Instruction (Instruction_PushScope )  =
    (sem_Instruction_PushScope )
sem_Instruction (Instruction_PushShort _val )  =
    (sem_Instruction_PushShort _val )
sem_Instruction (Instruction_PushString _name )  =
    (sem_Instruction_PushString _name )
sem_Instruction (Instruction_PushTrue )  =
    (sem_Instruction_PushTrue )
sem_Instruction (Instruction_PushUInt _name )  =
    (sem_Instruction_PushUInt _name )
sem_Instruction (Instruction_PushUndefined )  =
    (sem_Instruction_PushUndefined )
sem_Instruction (Instruction_PushWith )  =
    (sem_Instruction_PushWith )
sem_Instruction (Instruction_ReturnValue )  =
    (sem_Instruction_ReturnValue )
sem_Instruction (Instruction_ReturnVoid )  =
    (sem_Instruction_ReturnVoid )
sem_Instruction (Instruction_Rshift )  =
    (sem_Instruction_Rshift )
sem_Instruction (Instruction_SetGlobalSlot _slot )  =
    (sem_Instruction_SetGlobalSlot _slot )
sem_Instruction (Instruction_SetLocal _reg )  =
    (sem_Instruction_SetLocal _reg )
sem_Instruction (Instruction_SetLocal0 )  =
    (sem_Instruction_SetLocal0 )
sem_Instruction (Instruction_SetLocal1 )  =
    (sem_Instruction_SetLocal1 )
sem_Instruction (Instruction_SetLocal2 )  =
    (sem_Instruction_SetLocal2 )
sem_Instruction (Instruction_SetLocal3 )  =
    (sem_Instruction_SetLocal3 )
sem_Instruction (Instruction_SetProperty _name )  =
    (sem_Instruction_SetProperty _name )
sem_Instruction (Instruction_SetPropertyLate )  =
    (sem_Instruction_SetPropertyLate )
sem_Instruction (Instruction_SetSlot _slot )  =
    (sem_Instruction_SetSlot _slot )
sem_Instruction (Instruction_SetSuper _name )  =
    (sem_Instruction_SetSuper _name )
sem_Instruction (Instruction_SignExtend1 )  =
    (sem_Instruction_SignExtend1 )
sem_Instruction (Instruction_SignExtend16 )  =
    (sem_Instruction_SignExtend16 )
sem_Instruction (Instruction_SignExtend8 )  =
    (sem_Instruction_SignExtend8 )
sem_Instruction (Instruction_StoreFloat32 )  =
    (sem_Instruction_StoreFloat32 )
sem_Instruction (Instruction_StoreFloat64 )  =
    (sem_Instruction_StoreFloat64 )
sem_Instruction (Instruction_StoreIndirect16 )  =
    (sem_Instruction_StoreIndirect16 )
sem_Instruction (Instruction_StoreIndirect32 )  =
    (sem_Instruction_StoreIndirect32 )
sem_Instruction (Instruction_StoreIndirect8 )  =
    (sem_Instruction_StoreIndirect8 )
sem_Instruction (Instruction_StrictEquals )  =
    (sem_Instruction_StrictEquals )
sem_Instruction (Instruction_Substract )  =
    (sem_Instruction_Substract )
sem_Instruction (Instruction_Substract_i )  =
    (sem_Instruction_Substract_i )
sem_Instruction (Instruction_Swap )  =
    (sem_Instruction_Swap )
sem_Instruction (Instruction_Throw )  =
    (sem_Instruction_Throw )
sem_Instruction (Instruction_Timestamp )  =
    (sem_Instruction_Timestamp )
sem_Instruction (Instruction_TypeOf )  =
    (sem_Instruction_TypeOf )
sem_Instruction (Instruction_Urshift )  =
    (sem_Instruction_Urshift )
-- semantic domain
type T_Instruction  = ( Instruction )
sem_Instruction_Add :: T_Instruction 
sem_Instruction_Add  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_Add
            {-# LINE 902 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 907 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_Add_d :: T_Instruction 
sem_Instruction_Add_d  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_Add_d
            {-# LINE 915 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 920 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_Add_i :: T_Instruction 
sem_Instruction_Add_i  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_Add_i
            {-# LINE 928 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 933 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_ApplyType :: Word32 ->
                             T_Instruction 
sem_Instruction_ApplyType name_  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_ApplyType name_
            {-# LINE 942 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 947 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_AsType :: Word32 ->
                          T_Instruction 
sem_Instruction_AsType name_  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_AsType name_
            {-# LINE 956 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 961 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_AsTypeLate :: T_Instruction 
sem_Instruction_AsTypeLate  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_AsTypeLate
            {-# LINE 969 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 974 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_BitAnd :: T_Instruction 
sem_Instruction_BitAnd  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_BitAnd
            {-# LINE 982 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 987 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_BitNot :: T_Instruction 
sem_Instruction_BitNot  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_BitNot
            {-# LINE 995 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 1000 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_BitOr :: T_Instruction 
sem_Instruction_BitOr  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_BitOr
            {-# LINE 1008 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 1013 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_BitXor :: T_Instruction 
sem_Instruction_BitXor  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_BitXor
            {-# LINE 1021 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 1026 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_BreakLine :: Word32 ->
                             T_Instruction 
sem_Instruction_BreakLine line_  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_BreakLine line_
            {-# LINE 1035 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 1040 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_Breakpoint :: T_Instruction 
sem_Instruction_Breakpoint  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_Breakpoint
            {-# LINE 1048 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 1053 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_Call :: Word32 ->
                        T_Instruction 
sem_Instruction_Call argCount_  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_Call argCount_
            {-# LINE 1062 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 1067 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_CallInterface :: Word32 ->
                                 Word32 ->
                                 T_Instruction 
sem_Instruction_CallInterface name_ argCount_  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_CallInterface name_ argCount_
            {-# LINE 1077 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 1082 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_CallMethod :: Word32 ->
                              Word32 ->
                              T_Instruction 
sem_Instruction_CallMethod index_ argCount_  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_CallMethod index_ argCount_
            {-# LINE 1092 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 1097 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_CallProp :: Word32 ->
                            Word32 ->
                            T_Instruction 
sem_Instruction_CallProp name_ argCount_  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_CallProp name_ argCount_
            {-# LINE 1107 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 1112 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_CallPropLex :: Word32 ->
                               Word32 ->
                               T_Instruction 
sem_Instruction_CallPropLex name_ argCount_  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_CallPropLex name_ argCount_
            {-# LINE 1122 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 1127 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_CallPropVoid :: Word32 ->
                                Word32 ->
                                T_Instruction 
sem_Instruction_CallPropVoid name_ argCount_  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_CallPropVoid name_ argCount_
            {-# LINE 1137 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 1142 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_CallStatic :: Word32 ->
                              Word32 ->
                              T_Instruction 
sem_Instruction_CallStatic method_ argCount_  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_CallStatic method_ argCount_
            {-# LINE 1152 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 1157 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_CallSuper :: Word32 ->
                             Word32 ->
                             T_Instruction 
sem_Instruction_CallSuper name_ argCount_  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_CallSuper name_ argCount_
            {-# LINE 1167 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 1172 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_CallSuperId :: T_Instruction 
sem_Instruction_CallSuperId  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_CallSuperId
            {-# LINE 1180 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 1185 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_CallSuperVoid :: Word32 ->
                                 Word32 ->
                                 T_Instruction 
sem_Instruction_CallSuperVoid name_ argCount_  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_CallSuperVoid name_ argCount_
            {-# LINE 1195 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 1200 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_CheckFilter :: T_Instruction 
sem_Instruction_CheckFilter  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_CheckFilter
            {-# LINE 1208 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 1213 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_Coerce :: Word32 ->
                          T_Instruction 
sem_Instruction_Coerce name_  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_Coerce name_
            {-# LINE 1222 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 1227 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_Coerce_a :: T_Instruction 
sem_Instruction_Coerce_a  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_Coerce_a
            {-# LINE 1235 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 1240 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_Coerce_b :: T_Instruction 
sem_Instruction_Coerce_b  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_Coerce_b
            {-# LINE 1248 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 1253 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_Coerce_d :: T_Instruction 
sem_Instruction_Coerce_d  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_Coerce_d
            {-# LINE 1261 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 1266 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_Coerce_i :: T_Instruction 
sem_Instruction_Coerce_i  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_Coerce_i
            {-# LINE 1274 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 1279 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_Coerce_o :: T_Instruction 
sem_Instruction_Coerce_o  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_Coerce_o
            {-# LINE 1287 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 1292 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_Coerce_s :: T_Instruction 
sem_Instruction_Coerce_s  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_Coerce_s
            {-# LINE 1300 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 1305 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_Coerce_u :: T_Instruction 
sem_Instruction_Coerce_u  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_Coerce_u
            {-# LINE 1313 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 1318 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_Concat :: T_Instruction 
sem_Instruction_Concat  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_Concat
            {-# LINE 1326 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 1331 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_Construct :: Word32 ->
                             T_Instruction 
sem_Instruction_Construct argCount_  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_Construct argCount_
            {-# LINE 1340 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 1345 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_ConstructProp :: Word32 ->
                                 Word32 ->
                                 T_Instruction 
sem_Instruction_ConstructProp name_ argCount_  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_ConstructProp name_ argCount_
            {-# LINE 1355 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 1360 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_ConstructSuper :: Word32 ->
                                  T_Instruction 
sem_Instruction_ConstructSuper argCount_  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_ConstructSuper argCount_
            {-# LINE 1369 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 1374 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_Convert_b :: T_Instruction 
sem_Instruction_Convert_b  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_Convert_b
            {-# LINE 1382 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 1387 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_Convert_d :: T_Instruction 
sem_Instruction_Convert_d  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_Convert_d
            {-# LINE 1395 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 1400 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_Convert_i :: T_Instruction 
sem_Instruction_Convert_i  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_Convert_i
            {-# LINE 1408 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 1413 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_Convert_o :: T_Instruction 
sem_Instruction_Convert_o  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_Convert_o
            {-# LINE 1421 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 1426 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_Convert_s :: T_Instruction 
sem_Instruction_Convert_s  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_Convert_s
            {-# LINE 1434 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 1439 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_Convert_u :: T_Instruction 
sem_Instruction_Convert_u  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_Convert_u
            {-# LINE 1447 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 1452 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_Debug :: T_DebugType  ->
                         Word32 ->
                         Word32 ->
                         Word32 ->
                         T_Instruction 
sem_Instruction_Debug tp_ name_ reg_ extra_  =
    (case (tp_ ) of
     { ( _tpIself) | True ->
         (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
                 Instruction_Debug _tpIself name_ reg_ extra_
                 {-# LINE 1466 "src/ExtractAbc.hs" #-}
                 )) of
          { _self | _self `seq` (True) ->
          (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
                  _self
                  {-# LINE 1471 "src/ExtractAbc.hs" #-}
                  )) of
           { _lhsOself | _lhsOself `seq` (True) ->
           ( _lhsOself) }) }) })
sem_Instruction_DebugFile :: Word32 ->
                             T_Instruction 
sem_Instruction_DebugFile name_  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_DebugFile name_
            {-# LINE 1480 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 1485 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_DebugLine :: Word32 ->
                             T_Instruction 
sem_Instruction_DebugLine line_  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_DebugLine line_
            {-# LINE 1494 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 1499 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_DecLocal :: Word32 ->
                            T_Instruction 
sem_Instruction_DecLocal reg_  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_DecLocal reg_
            {-# LINE 1508 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 1513 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_DecLocal_i :: Word32 ->
                              T_Instruction 
sem_Instruction_DecLocal_i reg_  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_DecLocal_i reg_
            {-# LINE 1522 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 1527 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_Decrement :: T_Instruction 
sem_Instruction_Decrement  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_Decrement
            {-# LINE 1535 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 1540 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_Decrement_i :: T_Instruction 
sem_Instruction_Decrement_i  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_Decrement_i
            {-# LINE 1548 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 1553 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_DeleteProperty :: Word32 ->
                                  T_Instruction 
sem_Instruction_DeleteProperty name_  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_DeleteProperty name_
            {-# LINE 1562 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 1567 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_DeletePropertyLate :: T_Instruction 
sem_Instruction_DeletePropertyLate  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_DeletePropertyLate
            {-# LINE 1575 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 1580 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_Divide :: T_Instruction 
sem_Instruction_Divide  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_Divide
            {-# LINE 1588 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 1593 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_Dup :: T_Instruction 
sem_Instruction_Dup  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_Dup
            {-# LINE 1601 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 1606 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_Dxns :: Word32 ->
                        T_Instruction 
sem_Instruction_Dxns name_  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_Dxns name_
            {-# LINE 1615 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 1620 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_DxnsLate :: T_Instruction 
sem_Instruction_DxnsLate  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_DxnsLate
            {-# LINE 1628 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 1633 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_Equals :: T_Instruction 
sem_Instruction_Equals  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_Equals
            {-# LINE 1641 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 1646 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_EscXAttr :: T_Instruction 
sem_Instruction_EscXAttr  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_EscXAttr
            {-# LINE 1654 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 1659 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_EscXElem :: T_Instruction 
sem_Instruction_EscXElem  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_EscXElem
            {-# LINE 1667 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 1672 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_FindDef :: Word32 ->
                           T_Instruction 
sem_Instruction_FindDef name_  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_FindDef name_
            {-# LINE 1681 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 1686 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_FindPropStrict :: Word32 ->
                                  T_Instruction 
sem_Instruction_FindPropStrict name_  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_FindPropStrict name_
            {-# LINE 1695 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 1700 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_FindProperty :: Word32 ->
                                T_Instruction 
sem_Instruction_FindProperty name_  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_FindProperty name_
            {-# LINE 1709 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 1714 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_FindPropertyGlobal :: Word32 ->
                                      T_Instruction 
sem_Instruction_FindPropertyGlobal name_  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_FindPropertyGlobal name_
            {-# LINE 1723 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 1728 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_FindPropertyGlobalStrict :: Word32 ->
                                            T_Instruction 
sem_Instruction_FindPropertyGlobalStrict name_  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_FindPropertyGlobalStrict name_
            {-# LINE 1737 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 1742 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_GetDescendants :: Word32 ->
                                  T_Instruction 
sem_Instruction_GetDescendants name_  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_GetDescendants name_
            {-# LINE 1751 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 1756 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_GetGlobalScope :: T_Instruction 
sem_Instruction_GetGlobalScope  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_GetGlobalScope
            {-# LINE 1764 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 1769 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_GetGlobalSlot :: Word32 ->
                                 T_Instruction 
sem_Instruction_GetGlobalSlot slot_  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_GetGlobalSlot slot_
            {-# LINE 1778 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 1783 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_GetLex :: Word32 ->
                          T_Instruction 
sem_Instruction_GetLex name_  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_GetLex name_
            {-# LINE 1792 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 1797 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_GetLocal :: Word32 ->
                            T_Instruction 
sem_Instruction_GetLocal reg_  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_GetLocal reg_
            {-# LINE 1806 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 1811 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_GetLocal0 :: T_Instruction 
sem_Instruction_GetLocal0  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_GetLocal0
            {-# LINE 1819 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 1824 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_GetLocal1 :: T_Instruction 
sem_Instruction_GetLocal1  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_GetLocal1
            {-# LINE 1832 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 1837 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_GetLocal2 :: T_Instruction 
sem_Instruction_GetLocal2  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_GetLocal2
            {-# LINE 1845 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 1850 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_GetLocal3 :: T_Instruction 
sem_Instruction_GetLocal3  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_GetLocal3
            {-# LINE 1858 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 1863 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_GetOuterScope :: Word32 ->
                                 T_Instruction 
sem_Instruction_GetOuterScope name_  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_GetOuterScope name_
            {-# LINE 1872 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 1877 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_GetProperty :: Word32 ->
                               T_Instruction 
sem_Instruction_GetProperty name_  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_GetProperty name_
            {-# LINE 1886 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 1891 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_GetScopeObject :: Word8 ->
                                  T_Instruction 
sem_Instruction_GetScopeObject index_  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_GetScopeObject index_
            {-# LINE 1900 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 1905 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_GetSlot :: Word32 ->
                           T_Instruction 
sem_Instruction_GetSlot slot_  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_GetSlot slot_
            {-# LINE 1914 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 1919 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_GetSuper :: Word32 ->
                            T_Instruction 
sem_Instruction_GetSuper name_  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_GetSuper name_
            {-# LINE 1928 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 1933 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_GreaterEquals :: T_Instruction 
sem_Instruction_GreaterEquals  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_GreaterEquals
            {-# LINE 1941 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 1946 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_GreaterThan :: T_Instruction 
sem_Instruction_GreaterThan  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_GreaterThan
            {-# LINE 1954 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 1959 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_HasNext :: T_Instruction 
sem_Instruction_HasNext  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_HasNext
            {-# LINE 1967 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 1972 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_HasNext2 :: Word32 ->
                            Word32 ->
                            T_Instruction 
sem_Instruction_HasNext2 objectReg_ indexReg_  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_HasNext2 objectReg_ indexReg_
            {-# LINE 1982 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 1987 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_IfEq :: Word32 ->
                        T_Instruction 
sem_Instruction_IfEq offset_  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_IfEq offset_
            {-# LINE 1996 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 2001 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_IfFalse :: Word32 ->
                           T_Instruction 
sem_Instruction_IfFalse offset_  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_IfFalse offset_
            {-# LINE 2010 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 2015 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_IfGe :: Word32 ->
                        T_Instruction 
sem_Instruction_IfGe offset_  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_IfGe offset_
            {-# LINE 2024 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 2029 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_IfGt :: Word32 ->
                        T_Instruction 
sem_Instruction_IfGt offset_  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_IfGt offset_
            {-# LINE 2038 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 2043 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_IfLe :: Word32 ->
                        T_Instruction 
sem_Instruction_IfLe offset_  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_IfLe offset_
            {-# LINE 2052 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 2057 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_IfLt :: Word32 ->
                        T_Instruction 
sem_Instruction_IfLt offset_  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_IfLt offset_
            {-# LINE 2066 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 2071 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_IfNGe :: Word32 ->
                         T_Instruction 
sem_Instruction_IfNGe offset_  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_IfNGe offset_
            {-# LINE 2080 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 2085 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_IfNGt :: Word32 ->
                         T_Instruction 
sem_Instruction_IfNGt offset_  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_IfNGt offset_
            {-# LINE 2094 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 2099 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_IfNLe :: Word32 ->
                         T_Instruction 
sem_Instruction_IfNLe offset_  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_IfNLe offset_
            {-# LINE 2108 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 2113 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_IfNLt :: Word32 ->
                         T_Instruction 
sem_Instruction_IfNLt offset_  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_IfNLt offset_
            {-# LINE 2122 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 2127 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_IfNe :: Word32 ->
                        T_Instruction 
sem_Instruction_IfNe offset_  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_IfNe offset_
            {-# LINE 2136 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 2141 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_IfStrictEq :: Word32 ->
                              T_Instruction 
sem_Instruction_IfStrictEq offset_  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_IfStrictEq offset_
            {-# LINE 2150 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 2155 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_IfStrictNe :: Word32 ->
                              T_Instruction 
sem_Instruction_IfStrictNe offset_  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_IfStrictNe offset_
            {-# LINE 2164 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 2169 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_IfTrue :: Word32 ->
                          T_Instruction 
sem_Instruction_IfTrue offset_  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_IfTrue offset_
            {-# LINE 2178 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 2183 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_In :: T_Instruction 
sem_Instruction_In  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_In
            {-# LINE 2191 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 2196 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_IncLocal :: Word32 ->
                            T_Instruction 
sem_Instruction_IncLocal reg_  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_IncLocal reg_
            {-# LINE 2205 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 2210 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_IncLocal_i :: Word32 ->
                              T_Instruction 
sem_Instruction_IncLocal_i reg_  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_IncLocal_i reg_
            {-# LINE 2219 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 2224 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_Increment :: T_Instruction 
sem_Instruction_Increment  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_Increment
            {-# LINE 2232 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 2237 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_Increment_i :: T_Instruction 
sem_Instruction_Increment_i  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_Increment_i
            {-# LINE 2245 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 2250 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_InitProperty :: Word32 ->
                                T_Instruction 
sem_Instruction_InitProperty name_  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_InitProperty name_
            {-# LINE 2259 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 2264 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_InstanceOf :: T_Instruction 
sem_Instruction_InstanceOf  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_InstanceOf
            {-# LINE 2272 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 2277 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_IsType :: Word32 ->
                          T_Instruction 
sem_Instruction_IsType name_  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_IsType name_
            {-# LINE 2286 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 2291 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_IsTypeLate :: T_Instruction 
sem_Instruction_IsTypeLate  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_IsTypeLate
            {-# LINE 2299 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 2304 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_Jump :: Word32 ->
                        T_Instruction 
sem_Instruction_Jump offset_  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_Jump offset_
            {-# LINE 2313 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 2318 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_Kill :: Word32 ->
                        T_Instruction 
sem_Instruction_Kill reg_  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_Kill reg_
            {-# LINE 2327 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 2332 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_Label :: T_Instruction 
sem_Instruction_Label  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_Label
            {-# LINE 2340 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 2345 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_LessEquals :: T_Instruction 
sem_Instruction_LessEquals  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_LessEquals
            {-# LINE 2353 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 2358 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_LessThan :: T_Instruction 
sem_Instruction_LessThan  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_LessThan
            {-# LINE 2366 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 2371 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_LoadFloat32 :: T_Instruction 
sem_Instruction_LoadFloat32  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_LoadFloat32
            {-# LINE 2379 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 2384 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_LoadFloat64 :: T_Instruction 
sem_Instruction_LoadFloat64  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_LoadFloat64
            {-# LINE 2392 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 2397 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_LoadIndirect16 :: T_Instruction 
sem_Instruction_LoadIndirect16  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_LoadIndirect16
            {-# LINE 2405 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 2410 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_LoadIndirect32 :: T_Instruction 
sem_Instruction_LoadIndirect32  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_LoadIndirect32
            {-# LINE 2418 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 2423 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_LoadIndirect8 :: T_Instruction 
sem_Instruction_LoadIndirect8  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_LoadIndirect8
            {-# LINE 2431 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 2436 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_Location :: Int ->
                            T_Instruction 
sem_Instruction_Location index_  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_Location index_
            {-# LINE 2445 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 2450 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_LookupSwitch :: Word32 ->
                                T_CaseOffsets  ->
                                T_Instruction 
sem_Instruction_LookupSwitch defaultOffset_ caseOffsets_  =
    (case (caseOffsets_ ) of
     { ( _caseOffsetsIself) | True ->
         (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
                 Instruction_LookupSwitch defaultOffset_ _caseOffsetsIself
                 {-# LINE 2462 "src/ExtractAbc.hs" #-}
                 )) of
          { _self | _self `seq` (True) ->
          (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
                  _self
                  {-# LINE 2467 "src/ExtractAbc.hs" #-}
                  )) of
           { _lhsOself | _lhsOself `seq` (True) ->
           ( _lhsOself) }) }) })
sem_Instruction_Lshift :: T_Instruction 
sem_Instruction_Lshift  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_Lshift
            {-# LINE 2475 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 2480 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_Modulo :: T_Instruction 
sem_Instruction_Modulo  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_Modulo
            {-# LINE 2488 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 2493 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_Multiply :: T_Instruction 
sem_Instruction_Multiply  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_Multiply
            {-# LINE 2501 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 2506 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_Multiply_i :: T_Instruction 
sem_Instruction_Multiply_i  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_Multiply_i
            {-# LINE 2514 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 2519 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_Negate :: T_Instruction 
sem_Instruction_Negate  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_Negate
            {-# LINE 2527 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 2532 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_Negate_i :: T_Instruction 
sem_Instruction_Negate_i  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_Negate_i
            {-# LINE 2540 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 2545 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_NewActivation :: T_Instruction 
sem_Instruction_NewActivation  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_NewActivation
            {-# LINE 2553 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 2558 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_NewArray :: Word32 ->
                            T_Instruction 
sem_Instruction_NewArray argCount_  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_NewArray argCount_
            {-# LINE 2567 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 2572 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_NewCatch :: Word32 ->
                            T_Instruction 
sem_Instruction_NewCatch exception_  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_NewCatch exception_
            {-# LINE 2581 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 2586 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_NewClass :: Word32 ->
                            T_Instruction 
sem_Instruction_NewClass class_  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_NewClass class_
            {-# LINE 2595 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 2600 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_NewFunction :: Word32 ->
                               T_Instruction 
sem_Instruction_NewFunction method_  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_NewFunction method_
            {-# LINE 2609 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 2614 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_NewObject :: Word32 ->
                             T_Instruction 
sem_Instruction_NewObject argCount_  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_NewObject argCount_
            {-# LINE 2623 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 2628 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_NextName :: T_Instruction 
sem_Instruction_NextName  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_NextName
            {-# LINE 2636 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 2641 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_NextValue :: T_Instruction 
sem_Instruction_NextValue  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_NextValue
            {-# LINE 2649 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 2654 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_Nop :: T_Instruction 
sem_Instruction_Nop  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_Nop
            {-# LINE 2662 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 2667 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_Not :: T_Instruction 
sem_Instruction_Not  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_Not
            {-# LINE 2675 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 2680 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_Pop :: T_Instruction 
sem_Instruction_Pop  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_Pop
            {-# LINE 2688 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 2693 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_PopScope :: T_Instruction 
sem_Instruction_PopScope  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_PopScope
            {-# LINE 2701 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 2706 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_PushByte :: Word8 ->
                            T_Instruction 
sem_Instruction_PushByte val_  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_PushByte val_
            {-# LINE 2715 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 2720 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_PushDouble :: Word32 ->
                              T_Instruction 
sem_Instruction_PushDouble name_  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_PushDouble name_
            {-# LINE 2729 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 2734 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_PushFalse :: T_Instruction 
sem_Instruction_PushFalse  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_PushFalse
            {-# LINE 2742 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 2747 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_PushInt :: Word32 ->
                           T_Instruction 
sem_Instruction_PushInt name_  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_PushInt name_
            {-# LINE 2756 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 2761 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_PushNaN :: T_Instruction 
sem_Instruction_PushNaN  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_PushNaN
            {-# LINE 2769 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 2774 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_PushNamespace :: Word32 ->
                                 T_Instruction 
sem_Instruction_PushNamespace name_  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_PushNamespace name_
            {-# LINE 2783 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 2788 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_PushNull :: T_Instruction 
sem_Instruction_PushNull  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_PushNull
            {-# LINE 2796 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 2801 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_PushScope :: T_Instruction 
sem_Instruction_PushScope  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_PushScope
            {-# LINE 2809 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 2814 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_PushShort :: Word32 ->
                             T_Instruction 
sem_Instruction_PushShort val_  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_PushShort val_
            {-# LINE 2823 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 2828 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_PushString :: Word32 ->
                              T_Instruction 
sem_Instruction_PushString name_  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_PushString name_
            {-# LINE 2837 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 2842 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_PushTrue :: T_Instruction 
sem_Instruction_PushTrue  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_PushTrue
            {-# LINE 2850 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 2855 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_PushUInt :: Word32 ->
                            T_Instruction 
sem_Instruction_PushUInt name_  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_PushUInt name_
            {-# LINE 2864 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 2869 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_PushUndefined :: T_Instruction 
sem_Instruction_PushUndefined  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_PushUndefined
            {-# LINE 2877 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 2882 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_PushWith :: T_Instruction 
sem_Instruction_PushWith  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_PushWith
            {-# LINE 2890 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 2895 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_ReturnValue :: T_Instruction 
sem_Instruction_ReturnValue  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_ReturnValue
            {-# LINE 2903 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 2908 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_ReturnVoid :: T_Instruction 
sem_Instruction_ReturnVoid  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_ReturnVoid
            {-# LINE 2916 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 2921 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_Rshift :: T_Instruction 
sem_Instruction_Rshift  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_Rshift
            {-# LINE 2929 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 2934 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_SetGlobalSlot :: Word32 ->
                                 T_Instruction 
sem_Instruction_SetGlobalSlot slot_  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_SetGlobalSlot slot_
            {-# LINE 2943 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 2948 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_SetLocal :: Word32 ->
                            T_Instruction 
sem_Instruction_SetLocal reg_  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_SetLocal reg_
            {-# LINE 2957 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 2962 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_SetLocal0 :: T_Instruction 
sem_Instruction_SetLocal0  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_SetLocal0
            {-# LINE 2970 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 2975 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_SetLocal1 :: T_Instruction 
sem_Instruction_SetLocal1  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_SetLocal1
            {-# LINE 2983 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 2988 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_SetLocal2 :: T_Instruction 
sem_Instruction_SetLocal2  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_SetLocal2
            {-# LINE 2996 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 3001 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_SetLocal3 :: T_Instruction 
sem_Instruction_SetLocal3  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_SetLocal3
            {-# LINE 3009 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 3014 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_SetProperty :: Word32 ->
                               T_Instruction 
sem_Instruction_SetProperty name_  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_SetProperty name_
            {-# LINE 3023 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 3028 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_SetPropertyLate :: T_Instruction 
sem_Instruction_SetPropertyLate  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_SetPropertyLate
            {-# LINE 3036 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 3041 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_SetSlot :: Word32 ->
                           T_Instruction 
sem_Instruction_SetSlot slot_  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_SetSlot slot_
            {-# LINE 3050 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 3055 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_SetSuper :: Word32 ->
                            T_Instruction 
sem_Instruction_SetSuper name_  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_SetSuper name_
            {-# LINE 3064 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 3069 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_SignExtend1 :: T_Instruction 
sem_Instruction_SignExtend1  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_SignExtend1
            {-# LINE 3077 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 3082 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_SignExtend16 :: T_Instruction 
sem_Instruction_SignExtend16  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_SignExtend16
            {-# LINE 3090 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 3095 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_SignExtend8 :: T_Instruction 
sem_Instruction_SignExtend8  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_SignExtend8
            {-# LINE 3103 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 3108 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_StoreFloat32 :: T_Instruction 
sem_Instruction_StoreFloat32  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_StoreFloat32
            {-# LINE 3116 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 3121 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_StoreFloat64 :: T_Instruction 
sem_Instruction_StoreFloat64  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_StoreFloat64
            {-# LINE 3129 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 3134 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_StoreIndirect16 :: T_Instruction 
sem_Instruction_StoreIndirect16  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_StoreIndirect16
            {-# LINE 3142 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 3147 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_StoreIndirect32 :: T_Instruction 
sem_Instruction_StoreIndirect32  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_StoreIndirect32
            {-# LINE 3155 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 3160 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_StoreIndirect8 :: T_Instruction 
sem_Instruction_StoreIndirect8  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_StoreIndirect8
            {-# LINE 3168 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 3173 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_StrictEquals :: T_Instruction 
sem_Instruction_StrictEquals  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_StrictEquals
            {-# LINE 3181 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 3186 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_Substract :: T_Instruction 
sem_Instruction_Substract  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_Substract
            {-# LINE 3194 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 3199 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_Substract_i :: T_Instruction 
sem_Instruction_Substract_i  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_Substract_i
            {-# LINE 3207 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 3212 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_Swap :: T_Instruction 
sem_Instruction_Swap  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_Swap
            {-# LINE 3220 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 3225 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_Throw :: T_Instruction 
sem_Instruction_Throw  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_Throw
            {-# LINE 3233 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 3238 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_Timestamp :: T_Instruction 
sem_Instruction_Timestamp  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_Timestamp
            {-# LINE 3246 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 3251 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_TypeOf :: T_Instruction 
sem_Instruction_TypeOf  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_TypeOf
            {-# LINE 3259 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 3264 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_Instruction_Urshift :: T_Instruction 
sem_Instruction_Urshift  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            Instruction_Urshift
            {-# LINE 3272 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 3277 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
-- Instructions ------------------------------------------------
-- cata
sem_Instructions :: Instructions  ->
                    T_Instructions 
sem_Instructions list  =
    (Prelude.foldr sem_Instructions_Cons sem_Instructions_Nil (Prelude.map sem_Instruction list) )
-- semantic domain
type T_Instructions  = ( Instructions )
sem_Instructions_Cons :: T_Instruction  ->
                         T_Instructions  ->
                         T_Instructions 
sem_Instructions_Cons hd_ tl_  =
    (case (tl_ ) of
     { ( _tlIself) | True ->
         (case (hd_ ) of
          { ( _hdIself) | True ->
              (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
                      (:) _hdIself _tlIself
                      {-# LINE 3299 "src/ExtractAbc.hs" #-}
                      )) of
               { _self | _self `seq` (True) ->
               (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
                       _self
                       {-# LINE 3304 "src/ExtractAbc.hs" #-}
                       )) of
                { _lhsOself | _lhsOself `seq` (True) ->
                ( _lhsOself) }) }) }) })
sem_Instructions_Nil :: T_Instructions 
sem_Instructions_Nil  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            []
            {-# LINE 3312 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 3317 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
-- Interfaces --------------------------------------------------
-- cata
sem_Interfaces :: Interfaces  ->
                  T_Interfaces 
sem_Interfaces list  =
    (Prelude.foldr sem_Interfaces_Cons sem_Interfaces_Nil list )
-- semantic domain
type T_Interfaces  = ( Interfaces )
sem_Interfaces_Cons :: Word32 ->
                       T_Interfaces  ->
                       T_Interfaces 
sem_Interfaces_Cons hd_ tl_  =
    (case (tl_ ) of
     { ( _tlIself) | True ->
         (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
                 (:) hd_ _tlIself
                 {-# LINE 3337 "src/ExtractAbc.hs" #-}
                 )) of
          { _self | _self `seq` (True) ->
          (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
                  _self
                  {-# LINE 3342 "src/ExtractAbc.hs" #-}
                  )) of
           { _lhsOself | _lhsOself `seq` (True) ->
           ( _lhsOself) }) }) })
sem_Interfaces_Nil :: T_Interfaces 
sem_Interfaces_Nil  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            []
            {-# LINE 3350 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 3355 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
-- MetaInfo ----------------------------------------------------
-- cata
sem_MetaInfo :: MetaInfo  ->
                T_MetaInfo 
sem_MetaInfo (MetaInfo_Info _name _items )  =
    (sem_MetaInfo_Info _name (sem_MetaItems _items ) )
-- semantic domain
type T_MetaInfo  = ( MetaInfo )
sem_MetaInfo_Info :: Word32 ->
                     T_MetaItems  ->
                     T_MetaInfo 
sem_MetaInfo_Info name_ items_  =
    (case (items_ ) of
     { ( _itemsIself) | True ->
         (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
                 MetaInfo_Info name_ _itemsIself
                 {-# LINE 3375 "src/ExtractAbc.hs" #-}
                 )) of
          { _self | _self `seq` (True) ->
          (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
                  _self
                  {-# LINE 3380 "src/ExtractAbc.hs" #-}
                  )) of
           { _lhsOself | _lhsOself `seq` (True) ->
           ( _lhsOself) }) }) })
-- MetaInfos ---------------------------------------------------
-- cata
sem_MetaInfos :: MetaInfos  ->
                 T_MetaInfos 
sem_MetaInfos list  =
    (Prelude.foldr sem_MetaInfos_Cons sem_MetaInfos_Nil (Prelude.map sem_MetaInfo list) )
-- semantic domain
type T_MetaInfos  = ( MetaInfos )
sem_MetaInfos_Cons :: T_MetaInfo  ->
                      T_MetaInfos  ->
                      T_MetaInfos 
sem_MetaInfos_Cons hd_ tl_  =
    (case (tl_ ) of
     { ( _tlIself) | True ->
         (case (hd_ ) of
          { ( _hdIself) | True ->
              (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
                      (:) _hdIself _tlIself
                      {-# LINE 3402 "src/ExtractAbc.hs" #-}
                      )) of
               { _self | _self `seq` (True) ->
               (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
                       _self
                       {-# LINE 3407 "src/ExtractAbc.hs" #-}
                       )) of
                { _lhsOself | _lhsOself `seq` (True) ->
                ( _lhsOself) }) }) }) })
sem_MetaInfos_Nil :: T_MetaInfos 
sem_MetaInfos_Nil  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            []
            {-# LINE 3415 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 3420 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
-- MetaItem ----------------------------------------------------
-- cata
sem_MetaItem :: MetaItem  ->
                T_MetaItem 
sem_MetaItem (MetaItem_Item _key _value )  =
    (sem_MetaItem_Item _key _value )
-- semantic domain
type T_MetaItem  = ( MetaItem )
sem_MetaItem_Item :: Word32 ->
                     Word32 ->
                     T_MetaItem 
sem_MetaItem_Item key_ value_  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            MetaItem_Item key_ value_
            {-# LINE 3438 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 3443 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
-- MetaItems ---------------------------------------------------
-- cata
sem_MetaItems :: MetaItems  ->
                 T_MetaItems 
sem_MetaItems list  =
    (Prelude.foldr sem_MetaItems_Cons sem_MetaItems_Nil (Prelude.map sem_MetaItem list) )
-- semantic domain
type T_MetaItems  = ( MetaItems )
sem_MetaItems_Cons :: T_MetaItem  ->
                      T_MetaItems  ->
                      T_MetaItems 
sem_MetaItems_Cons hd_ tl_  =
    (case (tl_ ) of
     { ( _tlIself) | True ->
         (case (hd_ ) of
          { ( _hdIself) | True ->
              (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
                      (:) _hdIself _tlIself
                      {-# LINE 3465 "src/ExtractAbc.hs" #-}
                      )) of
               { _self | _self `seq` (True) ->
               (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
                       _self
                       {-# LINE 3470 "src/ExtractAbc.hs" #-}
                       )) of
                { _lhsOself | _lhsOself `seq` (True) ->
                ( _lhsOself) }) }) }) })
sem_MetaItems_Nil :: T_MetaItems 
sem_MetaItems_Nil  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            []
            {-# LINE 3478 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 3483 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
-- MethodFlag --------------------------------------------------
-- cata
sem_MethodFlag :: MethodFlag  ->
                  T_MethodFlag 
sem_MethodFlag (MethodFlag_HasOptionals )  =
    (sem_MethodFlag_HasOptionals )
sem_MethodFlag (MethodFlag_HasParamNames )  =
    (sem_MethodFlag_HasParamNames )
sem_MethodFlag (MethodFlag_NeedAct )  =
    (sem_MethodFlag_NeedAct )
sem_MethodFlag (MethodFlag_NeedArgs )  =
    (sem_MethodFlag_NeedArgs )
sem_MethodFlag (MethodFlag_NeedRest )  =
    (sem_MethodFlag_NeedRest )
sem_MethodFlag (MethodFlag_SetDXNS )  =
    (sem_MethodFlag_SetDXNS )
-- semantic domain
type T_MethodFlag  = ( MethodFlag )
sem_MethodFlag_HasOptionals :: T_MethodFlag 
sem_MethodFlag_HasOptionals  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            MethodFlag_HasOptionals
            {-# LINE 3509 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 3514 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_MethodFlag_HasParamNames :: T_MethodFlag 
sem_MethodFlag_HasParamNames  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            MethodFlag_HasParamNames
            {-# LINE 3522 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 3527 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_MethodFlag_NeedAct :: T_MethodFlag 
sem_MethodFlag_NeedAct  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            MethodFlag_NeedAct
            {-# LINE 3535 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 3540 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_MethodFlag_NeedArgs :: T_MethodFlag 
sem_MethodFlag_NeedArgs  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            MethodFlag_NeedArgs
            {-# LINE 3548 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 3553 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_MethodFlag_NeedRest :: T_MethodFlag 
sem_MethodFlag_NeedRest  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            MethodFlag_NeedRest
            {-# LINE 3561 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 3566 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_MethodFlag_SetDXNS :: T_MethodFlag 
sem_MethodFlag_SetDXNS  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            MethodFlag_SetDXNS
            {-# LINE 3574 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 3579 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
-- MethodFlags -------------------------------------------------
-- cata
sem_MethodFlags :: MethodFlags  ->
                   T_MethodFlags 
sem_MethodFlags list  =
    (Prelude.foldr sem_MethodFlags_Cons sem_MethodFlags_Nil (Prelude.map sem_MethodFlag list) )
-- semantic domain
type T_MethodFlags  = ( MethodFlags )
sem_MethodFlags_Cons :: T_MethodFlag  ->
                        T_MethodFlags  ->
                        T_MethodFlags 
sem_MethodFlags_Cons hd_ tl_  =
    (case (tl_ ) of
     { ( _tlIself) | True ->
         (case (hd_ ) of
          { ( _hdIself) | True ->
              (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
                      (:) _hdIself _tlIself
                      {-# LINE 3601 "src/ExtractAbc.hs" #-}
                      )) of
               { _self | _self `seq` (True) ->
               (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
                       _self
                       {-# LINE 3606 "src/ExtractAbc.hs" #-}
                       )) of
                { _lhsOself | _lhsOself `seq` (True) ->
                ( _lhsOself) }) }) }) })
sem_MethodFlags_Nil :: T_MethodFlags 
sem_MethodFlags_Nil  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            []
            {-# LINE 3614 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 3619 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
-- MethodInfo --------------------------------------------------
-- cata
sem_MethodInfo :: MethodInfo  ->
                  T_MethodInfo 
sem_MethodInfo (MethodInfo_Info _return _params _name _flags _options _names )  =
    (sem_MethodInfo_Info _return (sem_ParamTypes _params ) _name (sem_MethodFlags _flags ) (sem_Optionals _options ) (sem_ParamNames _names ) )
-- semantic domain
type T_MethodInfo  = ( MethodInfo )
sem_MethodInfo_Info :: Word32 ->
                       T_ParamTypes  ->
                       Word32 ->
                       T_MethodFlags  ->
                       T_Optionals  ->
                       T_ParamNames  ->
                       T_MethodInfo 
sem_MethodInfo_Info return_ params_ name_ flags_ options_ names_  =
    (case (names_ ) of
     { ( _namesIself) | True ->
         (case (options_ ) of
          { ( _optionsIself) | True ->
              (case (flags_ ) of
               { ( _flagsIself) | True ->
                   (case (params_ ) of
                    { ( _paramsIself) | True ->
                        (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
                                MethodInfo_Info return_ _paramsIself name_ _flagsIself _optionsIself _namesIself
                                {-# LINE 3649 "src/ExtractAbc.hs" #-}
                                )) of
                         { _self | _self `seq` (True) ->
                         (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
                                 _self
                                 {-# LINE 3654 "src/ExtractAbc.hs" #-}
                                 )) of
                          { _lhsOself | _lhsOself `seq` (True) ->
                          ( _lhsOself) }) }) }) }) }) })
-- MethodInfos -------------------------------------------------
-- cata
sem_MethodInfos :: MethodInfos  ->
                   T_MethodInfos 
sem_MethodInfos list  =
    (Prelude.foldr sem_MethodInfos_Cons sem_MethodInfos_Nil (Prelude.map sem_MethodInfo list) )
-- semantic domain
type T_MethodInfos  = ( MethodInfos )
sem_MethodInfos_Cons :: T_MethodInfo  ->
                        T_MethodInfos  ->
                        T_MethodInfos 
sem_MethodInfos_Cons hd_ tl_  =
    (case (tl_ ) of
     { ( _tlIself) | True ->
         (case (hd_ ) of
          { ( _hdIself) | True ->
              (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
                      (:) _hdIself _tlIself
                      {-# LINE 3676 "src/ExtractAbc.hs" #-}
                      )) of
               { _self | _self `seq` (True) ->
               (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
                       _self
                       {-# LINE 3681 "src/ExtractAbc.hs" #-}
                       )) of
                { _lhsOself | _lhsOself `seq` (True) ->
                ( _lhsOself) }) }) }) })
sem_MethodInfos_Nil :: T_MethodInfos 
sem_MethodInfos_Nil  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            []
            {-# LINE 3689 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 3694 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
-- MultinameInfo -----------------------------------------------
-- cata
sem_MultinameInfo :: MultinameInfo  ->
                     T_MultinameInfo 
sem_MultinameInfo (MultinameInfo_Generic _name _params )  =
    (sem_MultinameInfo_Generic _name (sem_ParamNames _params ) )
sem_MultinameInfo (MultinameInfo_Multiname _name _set )  =
    (sem_MultinameInfo_Multiname _name _set )
sem_MultinameInfo (MultinameInfo_MultinameA _name _set )  =
    (sem_MultinameInfo_MultinameA _name _set )
sem_MultinameInfo (MultinameInfo_MultinameL _set )  =
    (sem_MultinameInfo_MultinameL _set )
sem_MultinameInfo (MultinameInfo_MultinameLA _set )  =
    (sem_MultinameInfo_MultinameLA _set )
sem_MultinameInfo (MultinameInfo_QName _namespace _name )  =
    (sem_MultinameInfo_QName _namespace _name )
sem_MultinameInfo (MultinameInfo_QNameA _namespace _name )  =
    (sem_MultinameInfo_QNameA _namespace _name )
sem_MultinameInfo (MultinameInfo_RTQName _name )  =
    (sem_MultinameInfo_RTQName _name )
sem_MultinameInfo (MultinameInfo_RTQNameA _name )  =
    (sem_MultinameInfo_RTQNameA _name )
sem_MultinameInfo (MultinameInfo_RTQNameL )  =
    (sem_MultinameInfo_RTQNameL )
sem_MultinameInfo (MultinameInfo_RTQNameLA )  =
    (sem_MultinameInfo_RTQNameLA )
-- semantic domain
type T_MultinameInfo  = ( MultinameInfo )
sem_MultinameInfo_Generic :: Word32 ->
                             T_ParamNames  ->
                             T_MultinameInfo 
sem_MultinameInfo_Generic name_ params_  =
    (case (params_ ) of
     { ( _paramsIself) | True ->
         (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
                 MultinameInfo_Generic name_ _paramsIself
                 {-# LINE 3734 "src/ExtractAbc.hs" #-}
                 )) of
          { _self | _self `seq` (True) ->
          (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
                  _self
                  {-# LINE 3739 "src/ExtractAbc.hs" #-}
                  )) of
           { _lhsOself | _lhsOself `seq` (True) ->
           ( _lhsOself) }) }) })
sem_MultinameInfo_Multiname :: Word32 ->
                               Word32 ->
                               T_MultinameInfo 
sem_MultinameInfo_Multiname name_ set_  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            MultinameInfo_Multiname name_ set_
            {-# LINE 3749 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 3754 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_MultinameInfo_MultinameA :: Word32 ->
                                Word32 ->
                                T_MultinameInfo 
sem_MultinameInfo_MultinameA name_ set_  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            MultinameInfo_MultinameA name_ set_
            {-# LINE 3764 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 3769 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_MultinameInfo_MultinameL :: Word32 ->
                                T_MultinameInfo 
sem_MultinameInfo_MultinameL set_  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            MultinameInfo_MultinameL set_
            {-# LINE 3778 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 3783 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_MultinameInfo_MultinameLA :: Word32 ->
                                 T_MultinameInfo 
sem_MultinameInfo_MultinameLA set_  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            MultinameInfo_MultinameLA set_
            {-# LINE 3792 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 3797 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_MultinameInfo_QName :: Word32 ->
                           Word32 ->
                           T_MultinameInfo 
sem_MultinameInfo_QName namespace_ name_  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            MultinameInfo_QName namespace_ name_
            {-# LINE 3807 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 3812 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_MultinameInfo_QNameA :: Word32 ->
                            Word32 ->
                            T_MultinameInfo 
sem_MultinameInfo_QNameA namespace_ name_  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            MultinameInfo_QNameA namespace_ name_
            {-# LINE 3822 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 3827 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_MultinameInfo_RTQName :: Word32 ->
                             T_MultinameInfo 
sem_MultinameInfo_RTQName name_  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            MultinameInfo_RTQName name_
            {-# LINE 3836 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 3841 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_MultinameInfo_RTQNameA :: Word32 ->
                              T_MultinameInfo 
sem_MultinameInfo_RTQNameA name_  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            MultinameInfo_RTQNameA name_
            {-# LINE 3850 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 3855 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_MultinameInfo_RTQNameL :: T_MultinameInfo 
sem_MultinameInfo_RTQNameL  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            MultinameInfo_RTQNameL
            {-# LINE 3863 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 3868 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_MultinameInfo_RTQNameLA :: T_MultinameInfo 
sem_MultinameInfo_RTQNameLA  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            MultinameInfo_RTQNameLA
            {-# LINE 3876 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 3881 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
-- MultinameInfos ----------------------------------------------
-- cata
sem_MultinameInfos :: MultinameInfos  ->
                      T_MultinameInfos 
sem_MultinameInfos list  =
    (Prelude.foldr sem_MultinameInfos_Cons sem_MultinameInfos_Nil (Prelude.map sem_MultinameInfo list) )
-- semantic domain
type T_MultinameInfos  = ( MultinameInfos )
sem_MultinameInfos_Cons :: T_MultinameInfo  ->
                           T_MultinameInfos  ->
                           T_MultinameInfos 
sem_MultinameInfos_Cons hd_ tl_  =
    (case (tl_ ) of
     { ( _tlIself) | True ->
         (case (hd_ ) of
          { ( _hdIself) | True ->
              (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
                      (:) _hdIself _tlIself
                      {-# LINE 3903 "src/ExtractAbc.hs" #-}
                      )) of
               { _self | _self `seq` (True) ->
               (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
                       _self
                       {-# LINE 3908 "src/ExtractAbc.hs" #-}
                       )) of
                { _lhsOself | _lhsOself `seq` (True) ->
                ( _lhsOself) }) }) }) })
sem_MultinameInfos_Nil :: T_MultinameInfos 
sem_MultinameInfos_Nil  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            []
            {-# LINE 3916 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 3921 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
-- MultinameKind -----------------------------------------------
-- cata
sem_MultinameKind :: MultinameKind  ->
                     T_MultinameKind 
sem_MultinameKind (MultinameKind_Generic )  =
    (sem_MultinameKind_Generic )
sem_MultinameKind (MultinameKind_Multiname )  =
    (sem_MultinameKind_Multiname )
sem_MultinameKind (MultinameKind_MultinameA )  =
    (sem_MultinameKind_MultinameA )
sem_MultinameKind (MultinameKind_MultinameL )  =
    (sem_MultinameKind_MultinameL )
sem_MultinameKind (MultinameKind_MultinameLA )  =
    (sem_MultinameKind_MultinameLA )
sem_MultinameKind (MultinameKind_QName )  =
    (sem_MultinameKind_QName )
sem_MultinameKind (MultinameKind_QNameA )  =
    (sem_MultinameKind_QNameA )
sem_MultinameKind (MultinameKind_RTQName )  =
    (sem_MultinameKind_RTQName )
sem_MultinameKind (MultinameKind_RTQNameA )  =
    (sem_MultinameKind_RTQNameA )
sem_MultinameKind (MultinameKind_RTQNameL )  =
    (sem_MultinameKind_RTQNameL )
sem_MultinameKind (MultinameKind_RTQNameLA )  =
    (sem_MultinameKind_RTQNameLA )
-- semantic domain
type T_MultinameKind  = ( MultinameKind )
sem_MultinameKind_Generic :: T_MultinameKind 
sem_MultinameKind_Generic  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            MultinameKind_Generic
            {-# LINE 3957 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 3962 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_MultinameKind_Multiname :: T_MultinameKind 
sem_MultinameKind_Multiname  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            MultinameKind_Multiname
            {-# LINE 3970 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 3975 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_MultinameKind_MultinameA :: T_MultinameKind 
sem_MultinameKind_MultinameA  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            MultinameKind_MultinameA
            {-# LINE 3983 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 3988 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_MultinameKind_MultinameL :: T_MultinameKind 
sem_MultinameKind_MultinameL  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            MultinameKind_MultinameL
            {-# LINE 3996 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 4001 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_MultinameKind_MultinameLA :: T_MultinameKind 
sem_MultinameKind_MultinameLA  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            MultinameKind_MultinameLA
            {-# LINE 4009 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 4014 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_MultinameKind_QName :: T_MultinameKind 
sem_MultinameKind_QName  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            MultinameKind_QName
            {-# LINE 4022 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 4027 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_MultinameKind_QNameA :: T_MultinameKind 
sem_MultinameKind_QNameA  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            MultinameKind_QNameA
            {-# LINE 4035 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 4040 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_MultinameKind_RTQName :: T_MultinameKind 
sem_MultinameKind_RTQName  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            MultinameKind_RTQName
            {-# LINE 4048 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 4053 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_MultinameKind_RTQNameA :: T_MultinameKind 
sem_MultinameKind_RTQNameA  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            MultinameKind_RTQNameA
            {-# LINE 4061 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 4066 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_MultinameKind_RTQNameL :: T_MultinameKind 
sem_MultinameKind_RTQNameL  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            MultinameKind_RTQNameL
            {-# LINE 4074 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 4079 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_MultinameKind_RTQNameLA :: T_MultinameKind 
sem_MultinameKind_RTQNameLA  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            MultinameKind_RTQNameLA
            {-# LINE 4087 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 4092 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
-- NamespaceInfo -----------------------------------------------
-- cata
sem_NamespaceInfo :: NamespaceInfo  ->
                     T_NamespaceInfo 
sem_NamespaceInfo (NamespaceInfo_Info _kind _name )  =
    (sem_NamespaceInfo_Info (sem_NamespaceKind _kind ) _name )
-- semantic domain
type T_NamespaceInfo  = ( NamespaceInfo )
sem_NamespaceInfo_Info :: T_NamespaceKind  ->
                          Word32 ->
                          T_NamespaceInfo 
sem_NamespaceInfo_Info kind_ name_  =
    (case (kind_ ) of
     { ( _kindIself) | True ->
         (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
                 NamespaceInfo_Info _kindIself name_
                 {-# LINE 4112 "src/ExtractAbc.hs" #-}
                 )) of
          { _self | _self `seq` (True) ->
          (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
                  _self
                  {-# LINE 4117 "src/ExtractAbc.hs" #-}
                  )) of
           { _lhsOself | _lhsOself `seq` (True) ->
           ( _lhsOself) }) }) })
-- NamespaceInfos ----------------------------------------------
-- cata
sem_NamespaceInfos :: NamespaceInfos  ->
                      T_NamespaceInfos 
sem_NamespaceInfos list  =
    (Prelude.foldr sem_NamespaceInfos_Cons sem_NamespaceInfos_Nil (Prelude.map sem_NamespaceInfo list) )
-- semantic domain
type T_NamespaceInfos  = ( NamespaceInfos )
sem_NamespaceInfos_Cons :: T_NamespaceInfo  ->
                           T_NamespaceInfos  ->
                           T_NamespaceInfos 
sem_NamespaceInfos_Cons hd_ tl_  =
    (case (tl_ ) of
     { ( _tlIself) | True ->
         (case (hd_ ) of
          { ( _hdIself) | True ->
              (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
                      (:) _hdIself _tlIself
                      {-# LINE 4139 "src/ExtractAbc.hs" #-}
                      )) of
               { _self | _self `seq` (True) ->
               (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
                       _self
                       {-# LINE 4144 "src/ExtractAbc.hs" #-}
                       )) of
                { _lhsOself | _lhsOself `seq` (True) ->
                ( _lhsOself) }) }) }) })
sem_NamespaceInfos_Nil :: T_NamespaceInfos 
sem_NamespaceInfos_Nil  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            []
            {-# LINE 4152 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 4157 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
-- NamespaceKind -----------------------------------------------
-- cata
sem_NamespaceKind :: NamespaceKind  ->
                     T_NamespaceKind 
sem_NamespaceKind (NamespaceKind_Explicit )  =
    (sem_NamespaceKind_Explicit )
sem_NamespaceKind (NamespaceKind_General )  =
    (sem_NamespaceKind_General )
sem_NamespaceKind (NamespaceKind_Internal )  =
    (sem_NamespaceKind_Internal )
sem_NamespaceKind (NamespaceKind_Package )  =
    (sem_NamespaceKind_Package )
sem_NamespaceKind (NamespaceKind_Private )  =
    (sem_NamespaceKind_Private )
sem_NamespaceKind (NamespaceKind_Protected )  =
    (sem_NamespaceKind_Protected )
sem_NamespaceKind (NamespaceKind_Static )  =
    (sem_NamespaceKind_Static )
-- semantic domain
type T_NamespaceKind  = ( NamespaceKind )
sem_NamespaceKind_Explicit :: T_NamespaceKind 
sem_NamespaceKind_Explicit  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            NamespaceKind_Explicit
            {-# LINE 4185 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 4190 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_NamespaceKind_General :: T_NamespaceKind 
sem_NamespaceKind_General  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            NamespaceKind_General
            {-# LINE 4198 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 4203 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_NamespaceKind_Internal :: T_NamespaceKind 
sem_NamespaceKind_Internal  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            NamespaceKind_Internal
            {-# LINE 4211 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 4216 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_NamespaceKind_Package :: T_NamespaceKind 
sem_NamespaceKind_Package  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            NamespaceKind_Package
            {-# LINE 4224 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 4229 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_NamespaceKind_Private :: T_NamespaceKind 
sem_NamespaceKind_Private  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            NamespaceKind_Private
            {-# LINE 4237 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 4242 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_NamespaceKind_Protected :: T_NamespaceKind 
sem_NamespaceKind_Protected  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            NamespaceKind_Protected
            {-# LINE 4250 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 4255 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_NamespaceKind_Static :: T_NamespaceKind 
sem_NamespaceKind_Static  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            NamespaceKind_Static
            {-# LINE 4263 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 4268 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
-- NamespaceNames ----------------------------------------------
-- cata
sem_NamespaceNames :: NamespaceNames  ->
                      T_NamespaceNames 
sem_NamespaceNames list  =
    (Prelude.foldr sem_NamespaceNames_Cons sem_NamespaceNames_Nil list )
-- semantic domain
type T_NamespaceNames  = ( NamespaceNames )
sem_NamespaceNames_Cons :: Word32 ->
                           T_NamespaceNames  ->
                           T_NamespaceNames 
sem_NamespaceNames_Cons hd_ tl_  =
    (case (tl_ ) of
     { ( _tlIself) | True ->
         (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
                 (:) hd_ _tlIself
                 {-# LINE 4288 "src/ExtractAbc.hs" #-}
                 )) of
          { _self | _self `seq` (True) ->
          (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
                  _self
                  {-# LINE 4293 "src/ExtractAbc.hs" #-}
                  )) of
           { _lhsOself | _lhsOself `seq` (True) ->
           ( _lhsOself) }) }) })
sem_NamespaceNames_Nil :: T_NamespaceNames 
sem_NamespaceNames_Nil  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            []
            {-# LINE 4301 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 4306 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
-- Optional ----------------------------------------------------
-- cata
sem_Optional :: Optional  ->
                T_Optional 
sem_Optional (Optional_Detail _val _kind )  =
    (sem_Optional_Detail _val (sem_ValueKind _kind ) )
-- semantic domain
type T_Optional  = ( Optional )
sem_Optional_Detail :: Word32 ->
                       T_ValueKind  ->
                       T_Optional 
sem_Optional_Detail val_ kind_  =
    (case (kind_ ) of
     { ( _kindIself) | True ->
         (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
                 Optional_Detail val_ _kindIself
                 {-# LINE 4326 "src/ExtractAbc.hs" #-}
                 )) of
          { _self | _self `seq` (True) ->
          (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
                  _self
                  {-# LINE 4331 "src/ExtractAbc.hs" #-}
                  )) of
           { _lhsOself | _lhsOself `seq` (True) ->
           ( _lhsOself) }) }) })
-- Optionals ---------------------------------------------------
-- cata
sem_Optionals :: Optionals  ->
                 T_Optionals 
sem_Optionals list  =
    (Prelude.foldr sem_Optionals_Cons sem_Optionals_Nil (Prelude.map sem_Optional list) )
-- semantic domain
type T_Optionals  = ( Optionals )
sem_Optionals_Cons :: T_Optional  ->
                      T_Optionals  ->
                      T_Optionals 
sem_Optionals_Cons hd_ tl_  =
    (case (tl_ ) of
     { ( _tlIself) | True ->
         (case (hd_ ) of
          { ( _hdIself) | True ->
              (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
                      (:) _hdIself _tlIself
                      {-# LINE 4353 "src/ExtractAbc.hs" #-}
                      )) of
               { _self | _self `seq` (True) ->
               (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
                       _self
                       {-# LINE 4358 "src/ExtractAbc.hs" #-}
                       )) of
                { _lhsOself | _lhsOself `seq` (True) ->
                ( _lhsOself) }) }) }) })
sem_Optionals_Nil :: T_Optionals 
sem_Optionals_Nil  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            []
            {-# LINE 4366 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 4371 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
-- ParamNames --------------------------------------------------
-- cata
sem_ParamNames :: ParamNames  ->
                  T_ParamNames 
sem_ParamNames list  =
    (Prelude.foldr sem_ParamNames_Cons sem_ParamNames_Nil list )
-- semantic domain
type T_ParamNames  = ( ParamNames )
sem_ParamNames_Cons :: Word32 ->
                       T_ParamNames  ->
                       T_ParamNames 
sem_ParamNames_Cons hd_ tl_  =
    (case (tl_ ) of
     { ( _tlIself) | True ->
         (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
                 (:) hd_ _tlIself
                 {-# LINE 4391 "src/ExtractAbc.hs" #-}
                 )) of
          { _self | _self `seq` (True) ->
          (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
                  _self
                  {-# LINE 4396 "src/ExtractAbc.hs" #-}
                  )) of
           { _lhsOself | _lhsOself `seq` (True) ->
           ( _lhsOself) }) }) })
sem_ParamNames_Nil :: T_ParamNames 
sem_ParamNames_Nil  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            []
            {-# LINE 4404 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 4409 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
-- ParamTypes --------------------------------------------------
-- cata
sem_ParamTypes :: ParamTypes  ->
                  T_ParamTypes 
sem_ParamTypes list  =
    (Prelude.foldr sem_ParamTypes_Cons sem_ParamTypes_Nil list )
-- semantic domain
type T_ParamTypes  = ( ParamTypes )
sem_ParamTypes_Cons :: Word32 ->
                       T_ParamTypes  ->
                       T_ParamTypes 
sem_ParamTypes_Cons hd_ tl_  =
    (case (tl_ ) of
     { ( _tlIself) | True ->
         (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
                 (:) hd_ _tlIself
                 {-# LINE 4429 "src/ExtractAbc.hs" #-}
                 )) of
          { _self | _self `seq` (True) ->
          (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
                  _self
                  {-# LINE 4434 "src/ExtractAbc.hs" #-}
                  )) of
           { _lhsOself | _lhsOself `seq` (True) ->
           ( _lhsOself) }) }) })
sem_ParamTypes_Nil :: T_ParamTypes 
sem_ParamTypes_Nil  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            []
            {-# LINE 4442 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 4447 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
-- PoolDoubles -------------------------------------------------
-- cata
sem_PoolDoubles :: PoolDoubles  ->
                   T_PoolDoubles 
sem_PoolDoubles list  =
    (Prelude.foldr sem_PoolDoubles_Cons sem_PoolDoubles_Nil list )
-- semantic domain
type T_PoolDoubles  = ( PoolDoubles )
sem_PoolDoubles_Cons :: Double ->
                        T_PoolDoubles  ->
                        T_PoolDoubles 
sem_PoolDoubles_Cons hd_ tl_  =
    (case (tl_ ) of
     { ( _tlIself) | True ->
         (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
                 (:) hd_ _tlIself
                 {-# LINE 4467 "src/ExtractAbc.hs" #-}
                 )) of
          { _self | _self `seq` (True) ->
          (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
                  _self
                  {-# LINE 4472 "src/ExtractAbc.hs" #-}
                  )) of
           { _lhsOself | _lhsOself `seq` (True) ->
           ( _lhsOself) }) }) })
sem_PoolDoubles_Nil :: T_PoolDoubles 
sem_PoolDoubles_Nil  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            []
            {-# LINE 4480 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 4485 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
-- PoolInfo ----------------------------------------------------
-- cata
sem_PoolInfo :: PoolInfo  ->
                T_PoolInfo 
sem_PoolInfo (PoolInfo_Info _integers _uintegers _doubles _strings _namespaces _namesets _multinames )  =
    (sem_PoolInfo_Info (sem_PoolInts _integers ) (sem_PoolUInts _uintegers ) (sem_PoolDoubles _doubles ) (sem_PoolStrings _strings ) (sem_NamespaceInfos _namespaces ) (sem_SetInfos _namesets ) (sem_MultinameInfos _multinames ) )
-- semantic domain
type T_PoolInfo  = ( PoolInfo )
sem_PoolInfo_Info :: T_PoolInts  ->
                     T_PoolUInts  ->
                     T_PoolDoubles  ->
                     T_PoolStrings  ->
                     T_NamespaceInfos  ->
                     T_SetInfos  ->
                     T_MultinameInfos  ->
                     T_PoolInfo 
sem_PoolInfo_Info integers_ uintegers_ doubles_ strings_ namespaces_ namesets_ multinames_  =
    (case (multinames_ ) of
     { ( _multinamesIself) | True ->
         (case (namesets_ ) of
          { ( _namesetsIself) | True ->
              (case (namespaces_ ) of
               { ( _namespacesIself) | True ->
                   (case (strings_ ) of
                    { ( _stringsIself) | True ->
                        (case (doubles_ ) of
                         { ( _doublesIself) | True ->
                             (case (uintegers_ ) of
                              { ( _uintegersIself) | True ->
                                  (case (integers_ ) of
                                   { ( _integersIself) | True ->
                                       (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
                                               PoolInfo_Info _integersIself _uintegersIself _doublesIself _stringsIself _namespacesIself _namesetsIself _multinamesIself
                                               {-# LINE 4522 "src/ExtractAbc.hs" #-}
                                               )) of
                                        { _self | _self `seq` (True) ->
                                        (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
                                                _self
                                                {-# LINE 4527 "src/ExtractAbc.hs" #-}
                                                )) of
                                         { _lhsOself | _lhsOself `seq` (True) ->
                                         ( _lhsOself) }) }) }) }) }) }) }) }) })
-- PoolInts ----------------------------------------------------
-- cata
sem_PoolInts :: PoolInts  ->
                T_PoolInts 
sem_PoolInts list  =
    (Prelude.foldr sem_PoolInts_Cons sem_PoolInts_Nil list )
-- semantic domain
type T_PoolInts  = ( PoolInts )
sem_PoolInts_Cons :: Word32 ->
                     T_PoolInts  ->
                     T_PoolInts 
sem_PoolInts_Cons hd_ tl_  =
    (case (tl_ ) of
     { ( _tlIself) | True ->
         (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
                 (:) hd_ _tlIself
                 {-# LINE 4547 "src/ExtractAbc.hs" #-}
                 )) of
          { _self | _self `seq` (True) ->
          (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
                  _self
                  {-# LINE 4552 "src/ExtractAbc.hs" #-}
                  )) of
           { _lhsOself | _lhsOself `seq` (True) ->
           ( _lhsOself) }) }) })
sem_PoolInts_Nil :: T_PoolInts 
sem_PoolInts_Nil  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            []
            {-# LINE 4560 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 4565 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
-- PoolStrings -------------------------------------------------
-- cata
sem_PoolStrings :: PoolStrings  ->
                   T_PoolStrings 
sem_PoolStrings list  =
    (Prelude.foldr sem_PoolStrings_Cons sem_PoolStrings_Nil list )
-- semantic domain
type T_PoolStrings  = ( PoolStrings )
sem_PoolStrings_Cons :: ByteString ->
                        T_PoolStrings  ->
                        T_PoolStrings 
sem_PoolStrings_Cons hd_ tl_  =
    (case (tl_ ) of
     { ( _tlIself) | True ->
         (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
                 (:) hd_ _tlIself
                 {-# LINE 4585 "src/ExtractAbc.hs" #-}
                 )) of
          { _self | _self `seq` (True) ->
          (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
                  _self
                  {-# LINE 4590 "src/ExtractAbc.hs" #-}
                  )) of
           { _lhsOself | _lhsOself `seq` (True) ->
           ( _lhsOself) }) }) })
sem_PoolStrings_Nil :: T_PoolStrings 
sem_PoolStrings_Nil  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            []
            {-# LINE 4598 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 4603 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
-- PoolUInts ---------------------------------------------------
-- cata
sem_PoolUInts :: PoolUInts  ->
                 T_PoolUInts 
sem_PoolUInts list  =
    (Prelude.foldr sem_PoolUInts_Cons sem_PoolUInts_Nil list )
-- semantic domain
type T_PoolUInts  = ( PoolUInts )
sem_PoolUInts_Cons :: Word32 ->
                      T_PoolUInts  ->
                      T_PoolUInts 
sem_PoolUInts_Cons hd_ tl_  =
    (case (tl_ ) of
     { ( _tlIself) | True ->
         (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
                 (:) hd_ _tlIself
                 {-# LINE 4623 "src/ExtractAbc.hs" #-}
                 )) of
          { _self | _self `seq` (True) ->
          (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
                  _self
                  {-# LINE 4628 "src/ExtractAbc.hs" #-}
                  )) of
           { _lhsOself | _lhsOself `seq` (True) ->
           ( _lhsOself) }) }) })
sem_PoolUInts_Nil :: T_PoolUInts 
sem_PoolUInts_Nil  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            []
            {-# LINE 4636 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 4641 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
-- Rect --------------------------------------------------------
-- cata
sem_Rect :: Rect  ->
            T_Rect 
sem_Rect (Rect_Rect _bits _xMin _xMax _yMin _yMax )  =
    (sem_Rect_Rect _bits _xMin _xMax _yMin _yMax )
-- semantic domain
type T_Rect  = ( )
sem_Rect_Rect :: Int ->
                 Word32 ->
                 Word32 ->
                 Word32 ->
                 Word32 ->
                 T_Rect 
sem_Rect_Rect bits_ xMin_ xMax_ yMin_ yMax_  =
    ( )
-- ScriptInfo --------------------------------------------------
-- cata
sem_ScriptInfo :: ScriptInfo  ->
                  T_ScriptInfo 
sem_ScriptInfo (ScriptInfo_Info _method _traits )  =
    (sem_ScriptInfo_Info _method (sem_Traits _traits ) )
-- semantic domain
type T_ScriptInfo  = ( ScriptInfo )
sem_ScriptInfo_Info :: Word32 ->
                       T_Traits  ->
                       T_ScriptInfo 
sem_ScriptInfo_Info method_ traits_  =
    (case (traits_ ) of
     { ( _traitsIself) | True ->
         (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
                 ScriptInfo_Info method_ _traitsIself
                 {-# LINE 4677 "src/ExtractAbc.hs" #-}
                 )) of
          { _self | _self `seq` (True) ->
          (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
                  _self
                  {-# LINE 4682 "src/ExtractAbc.hs" #-}
                  )) of
           { _lhsOself | _lhsOself `seq` (True) ->
           ( _lhsOself) }) }) })
-- ScriptInfos -------------------------------------------------
-- cata
sem_ScriptInfos :: ScriptInfos  ->
                   T_ScriptInfos 
sem_ScriptInfos list  =
    (Prelude.foldr sem_ScriptInfos_Cons sem_ScriptInfos_Nil (Prelude.map sem_ScriptInfo list) )
-- semantic domain
type T_ScriptInfos  = ( ScriptInfos )
sem_ScriptInfos_Cons :: T_ScriptInfo  ->
                        T_ScriptInfos  ->
                        T_ScriptInfos 
sem_ScriptInfos_Cons hd_ tl_  =
    (case (tl_ ) of
     { ( _tlIself) | True ->
         (case (hd_ ) of
          { ( _hdIself) | True ->
              (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
                      (:) _hdIself _tlIself
                      {-# LINE 4704 "src/ExtractAbc.hs" #-}
                      )) of
               { _self | _self `seq` (True) ->
               (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
                       _self
                       {-# LINE 4709 "src/ExtractAbc.hs" #-}
                       )) of
                { _lhsOself | _lhsOself `seq` (True) ->
                ( _lhsOself) }) }) }) })
sem_ScriptInfos_Nil :: T_ScriptInfos 
sem_ScriptInfos_Nil  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            []
            {-# LINE 4717 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 4722 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
-- SetInfo -----------------------------------------------------
-- cata
sem_SetInfo :: SetInfo  ->
               T_SetInfo 
sem_SetInfo (SetInfo_Info _names )  =
    (sem_SetInfo_Info (sem_NamespaceNames _names ) )
-- semantic domain
type T_SetInfo  = ( SetInfo )
sem_SetInfo_Info :: T_NamespaceNames  ->
                    T_SetInfo 
sem_SetInfo_Info names_  =
    (case (names_ ) of
     { ( _namesIself) | True ->
         (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
                 SetInfo_Info _namesIself
                 {-# LINE 4741 "src/ExtractAbc.hs" #-}
                 )) of
          { _self | _self `seq` (True) ->
          (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
                  _self
                  {-# LINE 4746 "src/ExtractAbc.hs" #-}
                  )) of
           { _lhsOself | _lhsOself `seq` (True) ->
           ( _lhsOself) }) }) })
-- SetInfos ----------------------------------------------------
-- cata
sem_SetInfos :: SetInfos  ->
                T_SetInfos 
sem_SetInfos list  =
    (Prelude.foldr sem_SetInfos_Cons sem_SetInfos_Nil (Prelude.map sem_SetInfo list) )
-- semantic domain
type T_SetInfos  = ( SetInfos )
sem_SetInfos_Cons :: T_SetInfo  ->
                     T_SetInfos  ->
                     T_SetInfos 
sem_SetInfos_Cons hd_ tl_  =
    (case (tl_ ) of
     { ( _tlIself) | True ->
         (case (hd_ ) of
          { ( _hdIself) | True ->
              (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
                      (:) _hdIself _tlIself
                      {-# LINE 4768 "src/ExtractAbc.hs" #-}
                      )) of
               { _self | _self `seq` (True) ->
               (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
                       _self
                       {-# LINE 4773 "src/ExtractAbc.hs" #-}
                       )) of
                { _lhsOself | _lhsOself `seq` (True) ->
                ( _lhsOself) }) }) }) })
sem_SetInfos_Nil :: T_SetInfos 
sem_SetInfos_Nil  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            []
            {-# LINE 4781 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 4786 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
-- SwfFile -----------------------------------------------------
-- cata
sem_SwfFile :: SwfFile  ->
               T_SwfFile 
sem_SwfFile (SwfFile_File _compressed _version _length _size _rate _count _tags )  =
    (sem_SwfFile_File _compressed _version _length (sem_Rect _size ) _rate _count (sem_Tags _tags ) )
-- semantic domain
type T_SwfFile  = ( AbcFiles)
data Inh_SwfFile  = Inh_SwfFile {}
data Syn_SwfFile  = Syn_SwfFile {output_Syn_SwfFile :: !(AbcFiles)}
wrap_SwfFile :: T_SwfFile  ->
                Inh_SwfFile  ->
                Syn_SwfFile 
wrap_SwfFile sem (Inh_SwfFile )  =
    (let ( _lhsOoutput) | True = sem 
     in  (Syn_SwfFile _lhsOoutput ))
sem_SwfFile_File :: Bool ->
                    Word8 ->
                    Word32 ->
                    T_Rect  ->
                    Word16 ->
                    Word16 ->
                    T_Tags  ->
                    T_SwfFile 
sem_SwfFile_File compressed_ version_ length_ size_ rate_ count_ tags_  =
    (case (tags_ ) of
     { ( _tagsIoutput) | True ->
         (case (({-# LINE 26 "src/ExtractAbc.ag" #-}
                 _tagsIoutput
                 {-# LINE 4819 "src/ExtractAbc.hs" #-}
                 )) of
          { _lhsOoutput | _lhsOoutput `seq` (True) ->
          ( _lhsOoutput) }) })
-- Tag ---------------------------------------------------------
-- cata
sem_Tag :: Tag  ->
           T_Tag 
sem_Tag (Tag_Abc _flags _name _file )  =
    (sem_Tag_Abc (sem_AbcFlags _flags ) _name (sem_AbcFile _file ) )
sem_Tag (Tag_End )  =
    (sem_Tag_End )
sem_Tag (Tag_FileAttributes _useDirectBlit _useGPU _hasMetaData _hasAS3 _useNetwork )  =
    (sem_Tag_FileAttributes _useDirectBlit _useGPU _hasMetaData _hasAS3 _useNetwork )
sem_Tag (Tag_Opaque _kind _length _body )  =
    (sem_Tag_Opaque (sem_TagKind _kind ) _length _body )
-- semantic domain
type T_Tag  = ( AbcFiles)
sem_Tag_Abc :: T_AbcFlags  ->
               ByteString ->
               T_AbcFile  ->
               T_Tag 
sem_Tag_Abc flags_ name_ file_  =
    (case (({-# LINE 30 "src/ExtractAbc.ag" #-}
            []
            {-# LINE 4844 "src/ExtractAbc.hs" #-}
            )) of
     { _output_augmented_syn | _output_augmented_syn `seq` (True) ->
     (case (file_ ) of
      { ( _fileIself) | True ->
          (case (({-# LINE 30 "src/ExtractAbc.ag" #-}
                  (_fileIself:)
                  {-# LINE 4851 "src/ExtractAbc.hs" #-}
                  )) of
           { _output_augmented_f1 | _output_augmented_f1 `seq` (True) ->
           (case (({-# LINE 30 "src/ExtractAbc.ag" #-}
                   foldr ($) _output_augmented_syn [_output_augmented_f1]
                   {-# LINE 4856 "src/ExtractAbc.hs" #-}
                   )) of
            { _lhsOoutput | _lhsOoutput `seq` (True) ->
            ( _lhsOoutput) }) }) }) })
sem_Tag_End :: T_Tag 
sem_Tag_End  =
    (case (({-# LINE 26 "src/ExtractAbc.ag" #-}
            []
            {-# LINE 4864 "src/ExtractAbc.hs" #-}
            )) of
     { _lhsOoutput | _lhsOoutput `seq` (True) ->
     ( _lhsOoutput) })
sem_Tag_FileAttributes :: Bool ->
                          Bool ->
                          Bool ->
                          Bool ->
                          Bool ->
                          T_Tag 
sem_Tag_FileAttributes useDirectBlit_ useGPU_ hasMetaData_ hasAS3_ useNetwork_  =
    (case (({-# LINE 26 "src/ExtractAbc.ag" #-}
            []
            {-# LINE 4877 "src/ExtractAbc.hs" #-}
            )) of
     { _lhsOoutput | _lhsOoutput `seq` (True) ->
     ( _lhsOoutput) })
sem_Tag_Opaque :: T_TagKind  ->
                  Word32 ->
                  ByteString ->
                  T_Tag 
sem_Tag_Opaque kind_ length_ body_  =
    (case (({-# LINE 26 "src/ExtractAbc.ag" #-}
            []
            {-# LINE 4888 "src/ExtractAbc.hs" #-}
            )) of
     { _lhsOoutput | _lhsOoutput `seq` (True) ->
     ( _lhsOoutput) })
-- TagKind -----------------------------------------------------
-- cata
sem_TagKind :: TagKind  ->
               T_TagKind 
sem_TagKind (TagKind_CSMTextSettings )  =
    (sem_TagKind_CSMTextSettings )
sem_TagKind (TagKind_DefineBinaryData )  =
    (sem_TagKind_DefineBinaryData )
sem_TagKind (TagKind_DefineBits )  =
    (sem_TagKind_DefineBits )
sem_TagKind (TagKind_DefineBitsJPEG2 )  =
    (sem_TagKind_DefineBitsJPEG2 )
sem_TagKind (TagKind_DefineBitsJPEG3 )  =
    (sem_TagKind_DefineBitsJPEG3 )
sem_TagKind (TagKind_DefineBitsJPEG4 )  =
    (sem_TagKind_DefineBitsJPEG4 )
sem_TagKind (TagKind_DefineBitsLossless )  =
    (sem_TagKind_DefineBitsLossless )
sem_TagKind (TagKind_DefineBitsLossless2 )  =
    (sem_TagKind_DefineBitsLossless2 )
sem_TagKind (TagKind_DefineButton )  =
    (sem_TagKind_DefineButton )
sem_TagKind (TagKind_DefineButton2 )  =
    (sem_TagKind_DefineButton2 )
sem_TagKind (TagKind_DefineButtonCxform )  =
    (sem_TagKind_DefineButtonCxform )
sem_TagKind (TagKind_DefineButtonSound )  =
    (sem_TagKind_DefineButtonSound )
sem_TagKind (TagKind_DefineEditText )  =
    (sem_TagKind_DefineEditText )
sem_TagKind (TagKind_DefineFont )  =
    (sem_TagKind_DefineFont )
sem_TagKind (TagKind_DefineFont2 )  =
    (sem_TagKind_DefineFont2 )
sem_TagKind (TagKind_DefineFont3 )  =
    (sem_TagKind_DefineFont3 )
sem_TagKind (TagKind_DefineFont4 )  =
    (sem_TagKind_DefineFont4 )
sem_TagKind (TagKind_DefineFontAlignZones )  =
    (sem_TagKind_DefineFontAlignZones )
sem_TagKind (TagKind_DefineFontInfo )  =
    (sem_TagKind_DefineFontInfo )
sem_TagKind (TagKind_DefineFontInfo2 )  =
    (sem_TagKind_DefineFontInfo2 )
sem_TagKind (TagKind_DefineFontName )  =
    (sem_TagKind_DefineFontName )
sem_TagKind (TagKind_DefineMorphShape )  =
    (sem_TagKind_DefineMorphShape )
sem_TagKind (TagKind_DefineMorphShape2 )  =
    (sem_TagKind_DefineMorphShape2 )
sem_TagKind (TagKind_DefineScalingGrid )  =
    (sem_TagKind_DefineScalingGrid )
sem_TagKind (TagKind_DefineSceneAndFrameLabelData )  =
    (sem_TagKind_DefineSceneAndFrameLabelData )
sem_TagKind (TagKind_DefineShape )  =
    (sem_TagKind_DefineShape )
sem_TagKind (TagKind_DefineShape2 )  =
    (sem_TagKind_DefineShape2 )
sem_TagKind (TagKind_DefineShape3 )  =
    (sem_TagKind_DefineShape3 )
sem_TagKind (TagKind_DefineShape4 )  =
    (sem_TagKind_DefineShape4 )
sem_TagKind (TagKind_DefineSound )  =
    (sem_TagKind_DefineSound )
sem_TagKind (TagKind_DefineSprite )  =
    (sem_TagKind_DefineSprite )
sem_TagKind (TagKind_DefineText )  =
    (sem_TagKind_DefineText )
sem_TagKind (TagKind_DefineText2 )  =
    (sem_TagKind_DefineText2 )
sem_TagKind (TagKind_DefineVideoStream )  =
    (sem_TagKind_DefineVideoStream )
sem_TagKind (TagKind_DoABC )  =
    (sem_TagKind_DoABC )
sem_TagKind (TagKind_DoAction )  =
    (sem_TagKind_DoAction )
sem_TagKind (TagKind_DoInitAction )  =
    (sem_TagKind_DoInitAction )
sem_TagKind (TagKind_EnableDebugger )  =
    (sem_TagKind_EnableDebugger )
sem_TagKind (TagKind_EnableDebugger2 )  =
    (sem_TagKind_EnableDebugger2 )
sem_TagKind (TagKind_End )  =
    (sem_TagKind_End )
sem_TagKind (TagKind_ExportAssets )  =
    (sem_TagKind_ExportAssets )
sem_TagKind (TagKind_FileAttributes )  =
    (sem_TagKind_FileAttributes )
sem_TagKind (TagKind_FrameLabel )  =
    (sem_TagKind_FrameLabel )
sem_TagKind (TagKind_ImportAssets )  =
    (sem_TagKind_ImportAssets )
sem_TagKind (TagKind_ImportAssets2 )  =
    (sem_TagKind_ImportAssets2 )
sem_TagKind (TagKind_JPEGTables )  =
    (sem_TagKind_JPEGTables )
sem_TagKind (TagKind_Metadata )  =
    (sem_TagKind_Metadata )
sem_TagKind (TagKind_Other _code )  =
    (sem_TagKind_Other _code )
sem_TagKind (TagKind_PlaceObject )  =
    (sem_TagKind_PlaceObject )
sem_TagKind (TagKind_PlaceObject2 )  =
    (sem_TagKind_PlaceObject2 )
sem_TagKind (TagKind_PlaceObject3 )  =
    (sem_TagKind_PlaceObject3 )
sem_TagKind (TagKind_Protect )  =
    (sem_TagKind_Protect )
sem_TagKind (TagKind_RemoveObject )  =
    (sem_TagKind_RemoveObject )
sem_TagKind (TagKind_RemoveObject2 )  =
    (sem_TagKind_RemoveObject2 )
sem_TagKind (TagKind_ScriptLimits )  =
    (sem_TagKind_ScriptLimits )
sem_TagKind (TagKind_SetBackgroundColor )  =
    (sem_TagKind_SetBackgroundColor )
sem_TagKind (TagKind_SetTabIndex )  =
    (sem_TagKind_SetTabIndex )
sem_TagKind (TagKind_ShowFrame )  =
    (sem_TagKind_ShowFrame )
sem_TagKind (TagKind_SoundStreamBlock )  =
    (sem_TagKind_SoundStreamBlock )
sem_TagKind (TagKind_SoundStreamHead )  =
    (sem_TagKind_SoundStreamHead )
sem_TagKind (TagKind_SoundStreamHead2 )  =
    (sem_TagKind_SoundStreamHead2 )
sem_TagKind (TagKind_StartSound )  =
    (sem_TagKind_StartSound )
sem_TagKind (TagKind_StartSound2 )  =
    (sem_TagKind_StartSound2 )
sem_TagKind (TagKind_SymbolClass )  =
    (sem_TagKind_SymbolClass )
sem_TagKind (TagKind_VideoFrame )  =
    (sem_TagKind_VideoFrame )
-- semantic domain
type T_TagKind  = ( )
sem_TagKind_CSMTextSettings :: T_TagKind 
sem_TagKind_CSMTextSettings  =
    ( )
sem_TagKind_DefineBinaryData :: T_TagKind 
sem_TagKind_DefineBinaryData  =
    ( )
sem_TagKind_DefineBits :: T_TagKind 
sem_TagKind_DefineBits  =
    ( )
sem_TagKind_DefineBitsJPEG2 :: T_TagKind 
sem_TagKind_DefineBitsJPEG2  =
    ( )
sem_TagKind_DefineBitsJPEG3 :: T_TagKind 
sem_TagKind_DefineBitsJPEG3  =
    ( )
sem_TagKind_DefineBitsJPEG4 :: T_TagKind 
sem_TagKind_DefineBitsJPEG4  =
    ( )
sem_TagKind_DefineBitsLossless :: T_TagKind 
sem_TagKind_DefineBitsLossless  =
    ( )
sem_TagKind_DefineBitsLossless2 :: T_TagKind 
sem_TagKind_DefineBitsLossless2  =
    ( )
sem_TagKind_DefineButton :: T_TagKind 
sem_TagKind_DefineButton  =
    ( )
sem_TagKind_DefineButton2 :: T_TagKind 
sem_TagKind_DefineButton2  =
    ( )
sem_TagKind_DefineButtonCxform :: T_TagKind 
sem_TagKind_DefineButtonCxform  =
    ( )
sem_TagKind_DefineButtonSound :: T_TagKind 
sem_TagKind_DefineButtonSound  =
    ( )
sem_TagKind_DefineEditText :: T_TagKind 
sem_TagKind_DefineEditText  =
    ( )
sem_TagKind_DefineFont :: T_TagKind 
sem_TagKind_DefineFont  =
    ( )
sem_TagKind_DefineFont2 :: T_TagKind 
sem_TagKind_DefineFont2  =
    ( )
sem_TagKind_DefineFont3 :: T_TagKind 
sem_TagKind_DefineFont3  =
    ( )
sem_TagKind_DefineFont4 :: T_TagKind 
sem_TagKind_DefineFont4  =
    ( )
sem_TagKind_DefineFontAlignZones :: T_TagKind 
sem_TagKind_DefineFontAlignZones  =
    ( )
sem_TagKind_DefineFontInfo :: T_TagKind 
sem_TagKind_DefineFontInfo  =
    ( )
sem_TagKind_DefineFontInfo2 :: T_TagKind 
sem_TagKind_DefineFontInfo2  =
    ( )
sem_TagKind_DefineFontName :: T_TagKind 
sem_TagKind_DefineFontName  =
    ( )
sem_TagKind_DefineMorphShape :: T_TagKind 
sem_TagKind_DefineMorphShape  =
    ( )
sem_TagKind_DefineMorphShape2 :: T_TagKind 
sem_TagKind_DefineMorphShape2  =
    ( )
sem_TagKind_DefineScalingGrid :: T_TagKind 
sem_TagKind_DefineScalingGrid  =
    ( )
sem_TagKind_DefineSceneAndFrameLabelData :: T_TagKind 
sem_TagKind_DefineSceneAndFrameLabelData  =
    ( )
sem_TagKind_DefineShape :: T_TagKind 
sem_TagKind_DefineShape  =
    ( )
sem_TagKind_DefineShape2 :: T_TagKind 
sem_TagKind_DefineShape2  =
    ( )
sem_TagKind_DefineShape3 :: T_TagKind 
sem_TagKind_DefineShape3  =
    ( )
sem_TagKind_DefineShape4 :: T_TagKind 
sem_TagKind_DefineShape4  =
    ( )
sem_TagKind_DefineSound :: T_TagKind 
sem_TagKind_DefineSound  =
    ( )
sem_TagKind_DefineSprite :: T_TagKind 
sem_TagKind_DefineSprite  =
    ( )
sem_TagKind_DefineText :: T_TagKind 
sem_TagKind_DefineText  =
    ( )
sem_TagKind_DefineText2 :: T_TagKind 
sem_TagKind_DefineText2  =
    ( )
sem_TagKind_DefineVideoStream :: T_TagKind 
sem_TagKind_DefineVideoStream  =
    ( )
sem_TagKind_DoABC :: T_TagKind 
sem_TagKind_DoABC  =
    ( )
sem_TagKind_DoAction :: T_TagKind 
sem_TagKind_DoAction  =
    ( )
sem_TagKind_DoInitAction :: T_TagKind 
sem_TagKind_DoInitAction  =
    ( )
sem_TagKind_EnableDebugger :: T_TagKind 
sem_TagKind_EnableDebugger  =
    ( )
sem_TagKind_EnableDebugger2 :: T_TagKind 
sem_TagKind_EnableDebugger2  =
    ( )
sem_TagKind_End :: T_TagKind 
sem_TagKind_End  =
    ( )
sem_TagKind_ExportAssets :: T_TagKind 
sem_TagKind_ExportAssets  =
    ( )
sem_TagKind_FileAttributes :: T_TagKind 
sem_TagKind_FileAttributes  =
    ( )
sem_TagKind_FrameLabel :: T_TagKind 
sem_TagKind_FrameLabel  =
    ( )
sem_TagKind_ImportAssets :: T_TagKind 
sem_TagKind_ImportAssets  =
    ( )
sem_TagKind_ImportAssets2 :: T_TagKind 
sem_TagKind_ImportAssets2  =
    ( )
sem_TagKind_JPEGTables :: T_TagKind 
sem_TagKind_JPEGTables  =
    ( )
sem_TagKind_Metadata :: T_TagKind 
sem_TagKind_Metadata  =
    ( )
sem_TagKind_Other :: Word16 ->
                     T_TagKind 
sem_TagKind_Other code_  =
    ( )
sem_TagKind_PlaceObject :: T_TagKind 
sem_TagKind_PlaceObject  =
    ( )
sem_TagKind_PlaceObject2 :: T_TagKind 
sem_TagKind_PlaceObject2  =
    ( )
sem_TagKind_PlaceObject3 :: T_TagKind 
sem_TagKind_PlaceObject3  =
    ( )
sem_TagKind_Protect :: T_TagKind 
sem_TagKind_Protect  =
    ( )
sem_TagKind_RemoveObject :: T_TagKind 
sem_TagKind_RemoveObject  =
    ( )
sem_TagKind_RemoveObject2 :: T_TagKind 
sem_TagKind_RemoveObject2  =
    ( )
sem_TagKind_ScriptLimits :: T_TagKind 
sem_TagKind_ScriptLimits  =
    ( )
sem_TagKind_SetBackgroundColor :: T_TagKind 
sem_TagKind_SetBackgroundColor  =
    ( )
sem_TagKind_SetTabIndex :: T_TagKind 
sem_TagKind_SetTabIndex  =
    ( )
sem_TagKind_ShowFrame :: T_TagKind 
sem_TagKind_ShowFrame  =
    ( )
sem_TagKind_SoundStreamBlock :: T_TagKind 
sem_TagKind_SoundStreamBlock  =
    ( )
sem_TagKind_SoundStreamHead :: T_TagKind 
sem_TagKind_SoundStreamHead  =
    ( )
sem_TagKind_SoundStreamHead2 :: T_TagKind 
sem_TagKind_SoundStreamHead2  =
    ( )
sem_TagKind_StartSound :: T_TagKind 
sem_TagKind_StartSound  =
    ( )
sem_TagKind_StartSound2 :: T_TagKind 
sem_TagKind_StartSound2  =
    ( )
sem_TagKind_SymbolClass :: T_TagKind 
sem_TagKind_SymbolClass  =
    ( )
sem_TagKind_VideoFrame :: T_TagKind 
sem_TagKind_VideoFrame  =
    ( )
-- Tags --------------------------------------------------------
-- cata
sem_Tags :: Tags  ->
            T_Tags 
sem_Tags list  =
    (Prelude.foldr sem_Tags_Cons sem_Tags_Nil (Prelude.map sem_Tag list) )
-- semantic domain
type T_Tags  = ( AbcFiles)
sem_Tags_Cons :: T_Tag  ->
                 T_Tags  ->
                 T_Tags 
sem_Tags_Cons hd_ tl_  =
    (case (tl_ ) of
     { ( _tlIoutput) | True ->
         (case (hd_ ) of
          { ( _hdIoutput) | True ->
              (case (({-# LINE 26 "src/ExtractAbc.ag" #-}
                      _hdIoutput ++ _tlIoutput
                      {-# LINE 5242 "src/ExtractAbc.hs" #-}
                      )) of
               { _lhsOoutput | _lhsOoutput `seq` (True) ->
               ( _lhsOoutput) }) }) })
sem_Tags_Nil :: T_Tags 
sem_Tags_Nil  =
    (case (({-# LINE 26 "src/ExtractAbc.ag" #-}
            []
            {-# LINE 5250 "src/ExtractAbc.hs" #-}
            )) of
     { _lhsOoutput | _lhsOoutput `seq` (True) ->
     ( _lhsOoutput) })
-- Trait -------------------------------------------------------
-- cata
sem_Trait :: Trait  ->
             T_Trait 
sem_Trait (Trait_Trait _name _data _attrs _meta )  =
    (sem_Trait_Trait _name (sem_TraitData _data ) (sem_TraitAttrs _attrs ) (sem_TraitMeta _meta ) )
-- semantic domain
type T_Trait  = ( Trait )
sem_Trait_Trait :: Word32 ->
                   T_TraitData  ->
                   T_TraitAttrs  ->
                   T_TraitMeta  ->
                   T_Trait 
sem_Trait_Trait name_ data_ attrs_ meta_  =
    (case (meta_ ) of
     { ( _metaIself) | True ->
         (case (attrs_ ) of
          { ( _attrsIself) | True ->
              (case (data_ ) of
               { ( _dataIself) | True ->
                   (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
                           Trait_Trait name_ _dataIself _attrsIself _metaIself
                           {-# LINE 5276 "src/ExtractAbc.hs" #-}
                           )) of
                    { _self | _self `seq` (True) ->
                    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
                            _self
                            {-# LINE 5281 "src/ExtractAbc.hs" #-}
                            )) of
                     { _lhsOself | _lhsOself `seq` (True) ->
                     ( _lhsOself) }) }) }) }) })
-- TraitAttr ---------------------------------------------------
-- cata
sem_TraitAttr :: TraitAttr  ->
                 T_TraitAttr 
sem_TraitAttr (TraitAttr_Final )  =
    (sem_TraitAttr_Final )
sem_TraitAttr (TraitAttr_Metadata )  =
    (sem_TraitAttr_Metadata )
sem_TraitAttr (TraitAttr_Override )  =
    (sem_TraitAttr_Override )
-- semantic domain
type T_TraitAttr  = ( TraitAttr )
sem_TraitAttr_Final :: T_TraitAttr 
sem_TraitAttr_Final  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            TraitAttr_Final
            {-# LINE 5301 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 5306 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_TraitAttr_Metadata :: T_TraitAttr 
sem_TraitAttr_Metadata  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            TraitAttr_Metadata
            {-# LINE 5314 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 5319 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_TraitAttr_Override :: T_TraitAttr 
sem_TraitAttr_Override  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            TraitAttr_Override
            {-# LINE 5327 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 5332 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
-- TraitAttrs --------------------------------------------------
-- cata
sem_TraitAttrs :: TraitAttrs  ->
                  T_TraitAttrs 
sem_TraitAttrs list  =
    (Prelude.foldr sem_TraitAttrs_Cons sem_TraitAttrs_Nil (Prelude.map sem_TraitAttr list) )
-- semantic domain
type T_TraitAttrs  = ( TraitAttrs )
sem_TraitAttrs_Cons :: T_TraitAttr  ->
                       T_TraitAttrs  ->
                       T_TraitAttrs 
sem_TraitAttrs_Cons hd_ tl_  =
    (case (tl_ ) of
     { ( _tlIself) | True ->
         (case (hd_ ) of
          { ( _hdIself) | True ->
              (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
                      (:) _hdIself _tlIself
                      {-# LINE 5354 "src/ExtractAbc.hs" #-}
                      )) of
               { _self | _self `seq` (True) ->
               (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
                       _self
                       {-# LINE 5359 "src/ExtractAbc.hs" #-}
                       )) of
                { _lhsOself | _lhsOself `seq` (True) ->
                ( _lhsOself) }) }) }) })
sem_TraitAttrs_Nil :: T_TraitAttrs 
sem_TraitAttrs_Nil  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            []
            {-# LINE 5367 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 5372 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
-- TraitData ---------------------------------------------------
-- cata
sem_TraitData :: TraitData  ->
                 T_TraitData 
sem_TraitData (TraitData_Class _slotId _class )  =
    (sem_TraitData_Class _slotId _class )
sem_TraitData (TraitData_Const _slotId _tp _vindex _vkind )  =
    (sem_TraitData_Const _slotId _tp _vindex (sem_ValueKind _vkind ) )
sem_TraitData (TraitData_Function _dispId _method )  =
    (sem_TraitData_Function _dispId _method )
sem_TraitData (TraitData_Getter _dispId _method )  =
    (sem_TraitData_Getter _dispId _method )
sem_TraitData (TraitData_Method _dispId _method )  =
    (sem_TraitData_Method _dispId _method )
sem_TraitData (TraitData_Setter _dispId _method )  =
    (sem_TraitData_Setter _dispId _method )
sem_TraitData (TraitData_Slot _slotId _tp _vindex _vkind )  =
    (sem_TraitData_Slot _slotId _tp _vindex (sem_ValueKind _vkind ) )
-- semantic domain
type T_TraitData  = ( TraitData )
sem_TraitData_Class :: Word32 ->
                       Word32 ->
                       T_TraitData 
sem_TraitData_Class slotId_ class_  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            TraitData_Class slotId_ class_
            {-# LINE 5402 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 5407 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_TraitData_Const :: Word32 ->
                       Word32 ->
                       Word32 ->
                       T_ValueKind  ->
                       T_TraitData 
sem_TraitData_Const slotId_ tp_ vindex_ vkind_  =
    (case (vkind_ ) of
     { ( _vkindIself) | True ->
         (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
                 TraitData_Const slotId_ tp_ vindex_ _vkindIself
                 {-# LINE 5421 "src/ExtractAbc.hs" #-}
                 )) of
          { _self | _self `seq` (True) ->
          (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
                  _self
                  {-# LINE 5426 "src/ExtractAbc.hs" #-}
                  )) of
           { _lhsOself | _lhsOself `seq` (True) ->
           ( _lhsOself) }) }) })
sem_TraitData_Function :: Word32 ->
                          Word32 ->
                          T_TraitData 
sem_TraitData_Function dispId_ method_  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            TraitData_Function dispId_ method_
            {-# LINE 5436 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 5441 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_TraitData_Getter :: Word32 ->
                        Word32 ->
                        T_TraitData 
sem_TraitData_Getter dispId_ method_  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            TraitData_Getter dispId_ method_
            {-# LINE 5451 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 5456 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_TraitData_Method :: Word32 ->
                        Word32 ->
                        T_TraitData 
sem_TraitData_Method dispId_ method_  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            TraitData_Method dispId_ method_
            {-# LINE 5466 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 5471 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_TraitData_Setter :: Word32 ->
                        Word32 ->
                        T_TraitData 
sem_TraitData_Setter dispId_ method_  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            TraitData_Setter dispId_ method_
            {-# LINE 5481 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 5486 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_TraitData_Slot :: Word32 ->
                      Word32 ->
                      Word32 ->
                      T_ValueKind  ->
                      T_TraitData 
sem_TraitData_Slot slotId_ tp_ vindex_ vkind_  =
    (case (vkind_ ) of
     { ( _vkindIself) | True ->
         (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
                 TraitData_Slot slotId_ tp_ vindex_ _vkindIself
                 {-# LINE 5500 "src/ExtractAbc.hs" #-}
                 )) of
          { _self | _self `seq` (True) ->
          (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
                  _self
                  {-# LINE 5505 "src/ExtractAbc.hs" #-}
                  )) of
           { _lhsOself | _lhsOself `seq` (True) ->
           ( _lhsOself) }) }) })
-- TraitKind ---------------------------------------------------
-- cata
sem_TraitKind :: TraitKind  ->
                 T_TraitKind 
sem_TraitKind (TraitKind_Class )  =
    (sem_TraitKind_Class )
sem_TraitKind (TraitKind_Const )  =
    (sem_TraitKind_Const )
sem_TraitKind (TraitKind_Function )  =
    (sem_TraitKind_Function )
sem_TraitKind (TraitKind_Getter )  =
    (sem_TraitKind_Getter )
sem_TraitKind (TraitKind_Method )  =
    (sem_TraitKind_Method )
sem_TraitKind (TraitKind_Setter )  =
    (sem_TraitKind_Setter )
sem_TraitKind (TraitKind_Slot )  =
    (sem_TraitKind_Slot )
-- semantic domain
type T_TraitKind  = ( TraitKind )
sem_TraitKind_Class :: T_TraitKind 
sem_TraitKind_Class  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            TraitKind_Class
            {-# LINE 5533 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 5538 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_TraitKind_Const :: T_TraitKind 
sem_TraitKind_Const  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            TraitKind_Const
            {-# LINE 5546 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 5551 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_TraitKind_Function :: T_TraitKind 
sem_TraitKind_Function  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            TraitKind_Function
            {-# LINE 5559 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 5564 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_TraitKind_Getter :: T_TraitKind 
sem_TraitKind_Getter  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            TraitKind_Getter
            {-# LINE 5572 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 5577 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_TraitKind_Method :: T_TraitKind 
sem_TraitKind_Method  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            TraitKind_Method
            {-# LINE 5585 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 5590 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_TraitKind_Setter :: T_TraitKind 
sem_TraitKind_Setter  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            TraitKind_Setter
            {-# LINE 5598 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 5603 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_TraitKind_Slot :: T_TraitKind 
sem_TraitKind_Slot  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            TraitKind_Slot
            {-# LINE 5611 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 5616 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
-- TraitMeta ---------------------------------------------------
-- cata
sem_TraitMeta :: TraitMeta  ->
                 T_TraitMeta 
sem_TraitMeta list  =
    (Prelude.foldr sem_TraitMeta_Cons sem_TraitMeta_Nil list )
-- semantic domain
type T_TraitMeta  = ( TraitMeta )
sem_TraitMeta_Cons :: Word32 ->
                      T_TraitMeta  ->
                      T_TraitMeta 
sem_TraitMeta_Cons hd_ tl_  =
    (case (tl_ ) of
     { ( _tlIself) | True ->
         (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
                 (:) hd_ _tlIself
                 {-# LINE 5636 "src/ExtractAbc.hs" #-}
                 )) of
          { _self | _self `seq` (True) ->
          (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
                  _self
                  {-# LINE 5641 "src/ExtractAbc.hs" #-}
                  )) of
           { _lhsOself | _lhsOself `seq` (True) ->
           ( _lhsOself) }) }) })
sem_TraitMeta_Nil :: T_TraitMeta 
sem_TraitMeta_Nil  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            []
            {-# LINE 5649 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 5654 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
-- Traits ------------------------------------------------------
-- cata
sem_Traits :: Traits  ->
              T_Traits 
sem_Traits list  =
    (Prelude.foldr sem_Traits_Cons sem_Traits_Nil (Prelude.map sem_Trait list) )
-- semantic domain
type T_Traits  = ( Traits )
sem_Traits_Cons :: T_Trait  ->
                   T_Traits  ->
                   T_Traits 
sem_Traits_Cons hd_ tl_  =
    (case (tl_ ) of
     { ( _tlIself) | True ->
         (case (hd_ ) of
          { ( _hdIself) | True ->
              (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
                      (:) _hdIself _tlIself
                      {-# LINE 5676 "src/ExtractAbc.hs" #-}
                      )) of
               { _self | _self `seq` (True) ->
               (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
                       _self
                       {-# LINE 5681 "src/ExtractAbc.hs" #-}
                       )) of
                { _lhsOself | _lhsOself `seq` (True) ->
                ( _lhsOself) }) }) }) })
sem_Traits_Nil :: T_Traits 
sem_Traits_Nil  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            []
            {-# LINE 5689 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 5694 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
-- ValueKind ---------------------------------------------------
-- cata
sem_ValueKind :: ValueKind  ->
                 T_ValueKind 
sem_ValueKind (ValueKind_Double )  =
    (sem_ValueKind_Double )
sem_ValueKind (ValueKind_Explicit )  =
    (sem_ValueKind_Explicit )
sem_ValueKind (ValueKind_False )  =
    (sem_ValueKind_False )
sem_ValueKind (ValueKind_Int )  =
    (sem_ValueKind_Int )
sem_ValueKind (ValueKind_Internal )  =
    (sem_ValueKind_Internal )
sem_ValueKind (ValueKind_Namespace )  =
    (sem_ValueKind_Namespace )
sem_ValueKind (ValueKind_Null )  =
    (sem_ValueKind_Null )
sem_ValueKind (ValueKind_Package )  =
    (sem_ValueKind_Package )
sem_ValueKind (ValueKind_Private )  =
    (sem_ValueKind_Private )
sem_ValueKind (ValueKind_Protected )  =
    (sem_ValueKind_Protected )
sem_ValueKind (ValueKind_Static )  =
    (sem_ValueKind_Static )
sem_ValueKind (ValueKind_True )  =
    (sem_ValueKind_True )
sem_ValueKind (ValueKind_UInt )  =
    (sem_ValueKind_UInt )
sem_ValueKind (ValueKind_Undefined )  =
    (sem_ValueKind_Undefined )
sem_ValueKind (ValueKind_Utf8 )  =
    (sem_ValueKind_Utf8 )
-- semantic domain
type T_ValueKind  = ( ValueKind )
sem_ValueKind_Double :: T_ValueKind 
sem_ValueKind_Double  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            ValueKind_Double
            {-# LINE 5738 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 5743 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_ValueKind_Explicit :: T_ValueKind 
sem_ValueKind_Explicit  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            ValueKind_Explicit
            {-# LINE 5751 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 5756 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_ValueKind_False :: T_ValueKind 
sem_ValueKind_False  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            ValueKind_False
            {-# LINE 5764 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 5769 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_ValueKind_Int :: T_ValueKind 
sem_ValueKind_Int  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            ValueKind_Int
            {-# LINE 5777 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 5782 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_ValueKind_Internal :: T_ValueKind 
sem_ValueKind_Internal  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            ValueKind_Internal
            {-# LINE 5790 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 5795 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_ValueKind_Namespace :: T_ValueKind 
sem_ValueKind_Namespace  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            ValueKind_Namespace
            {-# LINE 5803 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 5808 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_ValueKind_Null :: T_ValueKind 
sem_ValueKind_Null  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            ValueKind_Null
            {-# LINE 5816 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 5821 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_ValueKind_Package :: T_ValueKind 
sem_ValueKind_Package  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            ValueKind_Package
            {-# LINE 5829 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 5834 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_ValueKind_Private :: T_ValueKind 
sem_ValueKind_Private  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            ValueKind_Private
            {-# LINE 5842 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 5847 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_ValueKind_Protected :: T_ValueKind 
sem_ValueKind_Protected  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            ValueKind_Protected
            {-# LINE 5855 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 5860 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_ValueKind_Static :: T_ValueKind 
sem_ValueKind_Static  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            ValueKind_Static
            {-# LINE 5868 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 5873 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_ValueKind_True :: T_ValueKind 
sem_ValueKind_True  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            ValueKind_True
            {-# LINE 5881 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 5886 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_ValueKind_UInt :: T_ValueKind 
sem_ValueKind_UInt  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            ValueKind_UInt
            {-# LINE 5894 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 5899 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_ValueKind_Undefined :: T_ValueKind 
sem_ValueKind_Undefined  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            ValueKind_Undefined
            {-# LINE 5907 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 5912 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })
sem_ValueKind_Utf8 :: T_ValueKind 
sem_ValueKind_Utf8  =
    (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
            ValueKind_Utf8
            {-# LINE 5920 "src/ExtractAbc.hs" #-}
            )) of
     { _self | _self `seq` (True) ->
     (case (({-# LINE 27 "src/ExtractAbc.ag" #-}
             _self
             {-# LINE 5925 "src/ExtractAbc.hs" #-}
             )) of
      { _lhsOself | _lhsOself `seq` (True) ->
      ( _lhsOself) }) })